'****************************************************************
'*  Name    : Test_Tips_and_Tricks.BAS                          *
'*  Author  : [Alberto Freixanet]                               *
'*  Notice  : Copyright (c) 2018 [AFreixanet]                   *
'*          : All Rights Reserved                               *
'*  Date    : 29/09/2018                                        *
'*  Version : 1.0                                               *
'*  Notes   :                                                   *
'*          :                                                   *
'****************************************************************
'/ Choose the include file depending of clock of ISIS CPU.
    Include "D:\MyIncFiles\proton18_16.inc"

'    Declare Float_Display_Type = Fast
'    Declare Float_Rounding = On             ' Round down to the nearest integer
'    Declare Reminders = Off
'    DECLARE LABEL_BANK_RESETS = ON
'    Declare Reminders = On
'    #define __INTERRUPTS_ENABLED 1

    Dim MyResultByte As Byte
    Dim MyResultWord As Word
    Dim MyResultSWord As SWord    
    Dim MyResultDword As Dword
    Dim MyResultFloat As Float

    Dim MyResultRDword As Word

    Dim MyInputByte As Byte
    Dim MyInputWord As Word
    Dim MyInputDword As Dword            
    Dim MyInputFloat As Float

    Dim WordLoop As Word
    Dim ByteLoop As Byte
    
' Place the String at the End of the Dim list
    Dim MyString1 As String * 25
    Dim MyDummyArray[241] As Byte Heap    
'/==============================================================================
'/ UARTs
'    $define _HRSOutTwoStopBitsInc_
' Others libraries.
'    $define _ADCaverageA_
'    $define _ADCaverageB_    
'    $define _CountUntil_
'    $define _HEXtoASCII_
'    $define _IDLOCS_
'    $define _HRSLStrg_
'    $define _DegC_DegF_
'    $define _Map8_
'    $define _Map16_
'    $define _MapF_    
'    $define _GIE_Save_
'    $define _DEVID1_
'    $define _BCDCounters_
'    $define _StringToFloat_
'    $define _DebounceByte_    
'    $define _MyRandom_
'    $define _GrayCode_

    $define __MEASURE_CODE_
'/------------------------------------------------------------------------------
    '/ Create your own path in the Hard disk D:\MyIncFiles. 
    Include "D:\MyIncFiles\TIPS_AND_TRICKS_V16.Inc"
'/==============================================================================
    GoTo OverMacros                              ' Jump over the subroutines
'/==============================================================================


'/==============================================================================
OverMacros:
'/==============================================================================
                            
'/###############################################################################
'/ Main Demo Program
'/ Use the ISIS program to test the code.
'/ Click the ISIS button in the toolbar and choose the PIC18_ALCD_VHB.DSN board with normal LCD.
'/###############################################################################
    Cls
MAIN:

    STARTSIZE(BASIC_CODE)
'/ The result is:
(*
    MESSG "NEW_MEASURE_"#BASIC_CODE
*)
'/------------------------------------------------------------------------------

    STARTSIZE(TEST1_CODE)
    '/ Looking for the value of BankA_End info.
    ASMParameter(BankA_End,0,MyResultWord)
    HRSOut "BankA_End info: ", Dec MyResultWord,CR
    '/ Value read in the asm file.
    '/ MESSG VALUE_PARAMETER#0#BANKA_END = 127
    HRSOut CR
    ENDSIZE(TEST1_CODE)

    '/ Looking for the value of Bank5_End info.
    ASMParameter(Bank5_End,1,MyResultWord)
    HRSOut "Bank5_End info: ", Dec MyResultWord,CR
    '/ Value read in the asm file.
    '/ MESSG VALUE_PARAMETER#1#BANK5_END = 1535
    HRSOut CR

    '/ Looking for the address of GEN4 variable.
    ASMParameter(GEN4,2,MyResultWord)
    HRSOut "Address of 'GEN4' Variable: ", Dec MyResultWord,CR
    '/ Value read in the asm file.
    '/ MESSG VALUE_PARAMETER#2#GEN4 = 2
    HRSOut CR
    
    '/ Looking for the value of RAM_Banks info.
    ASMParameter(RAM_Banks,3,MyResultWord)
    HRSOut "RAM_Banks info: ", Dec MyResultWord,CR
    '/ Value read in the asm file.
    '/ MESSG VALUE_PARAMETER#3#RAM_BANKS = 6
    HRSOut CR

    '/ Looking for the value of __IDLOC0 info.
    ASMParameter(__IDLOC0,3,MyResultDword)
    HRSOut "IDLOC0 address: ", IHex6 MyResultDword,CR
    '/ Value read in the asm file.
    '/ MESSG VALUE_PARAMETER#3#__IDLOC0 = 2097152
    HRSOut CR
    
    '/ Looking for the address of MyResultFloat variable.
    ASMParameter(MyResultFloat,4,MyResultWord)
    HRSOut "Address of 'MyResultFloat' Variable: ", Dec MyResultWord,CR
    '/ Value read in the asm file.
    '/ MESSG VALUE_PARAMETER#4#MYRESULTFLOAT = 30
    HRSOut CR
    
    '/ Looking for the infos of MyString1#25 variable. MyResultWord = Addres: MyResultByte = Number of Bank.
    BankRAM(MyString1#25,0,MyResultWord, MyResultByte)
    HRSOut "Address of 'MyString1#25' Variable: ", Dec MyResultWord," ", IHex MyResultWord,CR    
    HRSOut "Number Bank of 'MyString1#25' Variable: ", Dec MyResultByte,CR
    '/ Values read in the asm file.
    '/ MESSG "MACRO_BANKRAM"#0#_ADDRESS_VARIABLE_#MYSTRING1#25 = 75
    '/ MESSG "MACRO_BANKRAM"#0#_BANK_VARIABLE_#MYSTRING1#25 = 255
    If MyResultByte = 255 Then
        HRSOut "If the result is 255; means BankA (Acces RAM)",CR    
    EndIf
    HRSOut CR

    '/ Looking for the infos of MyDummyArray#240 variable.  MyResultWord = Addres: MyResultByte = Number of Bank.
    BankRAM(MyDummyArray#240,0,MyResultWord, MyResultByte)
    HRSOut "Address of 'MyDummyArray#240' Variable: ", Dec MyResultWord," ", IHex MyResultWord,CR    
    HRSOut "Number Bank of 'MyDummyArray#240' Variable: ", Dec MyResultByte,CR
    '/ Values read in the asm file.
    '/ MESSG "MACRO_BANKRAM"#0#_ADDRESS_VARIABLE_#MYDUMMYARRAY#240 = 318        
    '/ MESSG "MACRO_BANKRAM"#0#_BANK_VARIABLE_#MYDUMMYARRAY#240 = 1
    If MyResultByte = 255 Then
        HRSOut "If the result is 255; means BankA (Acces RAM)",CR    
    EndIf
    HRSOut CR

    STARTSIZE(BankRAM1_CODE)
    '/ Looking for the infos of MyVarWord variable.  MyResultWord = Addres: MyResultByte = Number of Bank.
    BankRAM(MyVarWord,1,MyResultWord,MyResultByte)
    HRSOut "Address of 'MyVarWord' Variable ", Dec MyResultWord," ", IHex MyResultWord,CR    
    HRSOut "Number Bank of 'MyVarWord' Variable: ", Dec MyResultByte,CR
    '/ Values read in the asm file.
    '/ MESSG "MACRO_BANKRAM"#1#_ADDRESS_VARIABLE_#MYVARWORD = 76
    '/ MESSG "MACRO_BANKRAM"#1#_BANK_VARIABLE_#MYVARWORD = 255
    If MyResultByte = 255 Then
        HRSOut "If the result is 255; means BankA (Acces RAM)",CR    
    EndIf
    ENDSIZE(BankRAM1_CODE)
    
    '/ The Dim is after the code!!!
    '/ It is not possible to read it with VapTr command.
    Dim MyVarWord As Word


    HRSOut "END TEST",CR 
'/------------------------------------------------------------------------------
    ENDSIZE(BASIC_CODE)
    '/ See the file.asm to know the number of bytes of the code.
'/ The result is:
(*
    MESSG SIZE_CODE#BASIC_CODE = 746[BYTES]                      = 373[WORDS]
    MESSG TIME_CODE#BASIC_CODE = 186500[NANOS]
*)
'/ The Data strings are not included, the code only. See the asm file.
'/ The TIME_CODE is not true because the delay of the UART transmision is not included.
'/ The calculations of time are not always well. Use this tecnique with small piece of code.    
'/##############################################################################
    End
'/==============================================================================



