'****************************************************************
'*  Name    : Test_Tips_and_Tricks.BAS                          *
'*  Author  : [Alberto Freixanet]                               *
'*  Notice  : Copyright (c) 2018 [AFreixanet]                   *
'*          : All Rights Reserved                               *
'*  Date    : 29/09/2018                                        *
'*  Version : 1.0                                               *
'*  Notes   : Check the Array Bit commands                      *
'*          : PDS Version 3.6.2.3                               *
'****************************************************************
'/ Choose the include file depending of clock of ISIS CPU.
    Include "D:\MyIncFiles\proton18_16.inc"

'    Declare Float_Display_Type = Fast
'    Declare Float_Rounding = On             ' Round down to the nearest integer
    Declare Watchdog = Off
'    Declare Reminders = Off
'    DECLARE LABEL_BANK_RESETS = ON
'    Declare Reminders = On
'    #define __INTERRUPTS_ENABLED 1
'    #define watchdog_req

    Dim MyResultByte As Byte
    Dim MyResultWord As Word
    Dim MyResultSWord As SWord    
    Dim MyResultDword As Dword
    Dim MyResultFloat As Float

    Dim MyResultRDword As Word

    Dim MyInputByte As Byte
    Dim MyInputWord As Word
    Dim MyInputDword As Dword            
    Dim MyInputFloat As Float

    Dim WordLoop As Word
    Dim ByteLoop As Byte
    
' Place the String at the End of the Dim list
    Symbol MyArray1Lenght = 5
    Dim MyArray1[MyArray1Lenght] As Byte Heap
'/==============================================================================
'/ UARTs
'    $define _HRSOutTwoStopBitsInc_
' Others libraries.
'    $define _ADCaverageA_
'    $define _ADCaverageB_    
'    $define _CountUntil_
'    $define _HEXtoASCII_
'    $define _IDLOCS_
'    $define _HRSLStrg_
'    $define _DegC_DegF_
'    $define _Map8_
'    $define _Map16_
'    $define _MapF_    
'    $define _GIE_Save_
'    $define _DEVID1_
'    $define _BCDCounters_
'    $define _StringToFloat_
'    $define _DebounceByte_    
    $define _MyRandom_
'    $define _GrayCode_
'    $define _RotateBits_
'    $define _BubbleSort_
'    $define _MedianFilter_
'    $define _CLL_
    $define _ArrayBit_

    $define __MEASURE_CODE_
'/------------------------------------------------------------------------------
    '/ Create your own path in the Hard disk D:\MyIncFiles. 
    Include "D:\MyIncFiles\TIPS_AND_TRICKS_V16.Inc"
'/==============================================================================
    GoTo OverMacros                              ' Jump over the subroutines
'/==============================================================================


'/==============================================================================
OverMacros:
'/==============================================================================
                            
'/###############################################################################
'/ Main Demo Program
'/ Use the ISIS program to test the code.
'/ Click the ISIS button in the toolbar and choose the PIC18_ALCD_VHB.DSN board with normal LCD. 
'/###############################################################################
    Cls
MAIN:
   STARTSIZE(ARRAYBITS_CODE)
'/------------------------------------------------------------------------------

    HRSOut "TESTING THE ARRAY BITS COMMANDS:",CR,CR

    MySeed($A385B341)

    '/ Get a Bit command.
    HRSOut "Get a Bit from the Array: Positions: 0,1,2,3,4,5,6,7",CR
    HRSOut "Bits Array: %"
    '/ Loading the array with random values.
    For ByteLoop = MyArray1Lenght -1 To 0 Step - 1
        MyResultByte = MyRandom(1)
        MyArray1[ByteLoop] = MyResultByte
        HRSOut Bin8 MyResultByte," "
    Next
    HRSOut CR

    MyResultByte = GetArrayBit(MyArray1,0)
    HRSOut "Get a Bit: Index 0 = ", Dec MyResultByte,CR 
    MyResultByte = GetArrayBit(MyArray1,1)
    HRSOut "Get a Bit: Index 1 = ", Dec MyResultByte,CR
    MyResultByte = GetArrayBit(MyArray1,2)
    HRSOut "Get a Bit: Index 2 = ", Dec MyResultByte,CR     
    MyResultByte = GetArrayBit(MyArray1,3)
    HRSOut "Get a Bit: Index 3 = ", Dec MyResultByte,CR     
    MyResultByte = GetArrayBit(MyArray1,4)
    HRSOut "Get a Bit: Index 4 = ", Dec MyResultByte,CR     
    MyResultByte = GetArrayBit(MyArray1,5)
    HRSOut "Get a Bit: Index 5 = ", Dec MyResultByte,CR     
    MyResultByte = GetArrayBit(MyArray1,6)
    HRSOut "Get a Bit: Index 6 = ", Dec MyResultByte,CR     
    MyResultByte = GetArrayBit(MyArray1,7)
    HRSOut "Get a Bit: Index 7 = ", Dec MyResultByte,CR     
    HRSOut CR

    '/
    '/ Write a Bit 1 command.    
    HRSOut "Write a Bit 1 into the Array: Positions: 8,9,10,11",CR
    WriteArrayBit(MyArray1,8,1)
    HRSOut "Write a Bit: Index 8  = 1",CR 
    WriteArrayBit(MyArray1,9,1)
    HRSOut "Write a Bit: Index 9  = 1",CR
    WriteArrayBit(MyArray1,10,1)
    HRSOut "Write a Bit: Index 10 = 1",CR     
    WriteArrayBit(MyArray1,11,1)
    HRSOut "Write a Bit: Index 11 = 1",CR  

    HRSOut "Bits Array: %"
    '/ Print the array .
    For ByteLoop = MyArray1Lenght -1 To 0 Step - 1
        MyResultByte = MyArray1[ByteLoop] 
        HRSOut Bin8 MyResultByte," "
    Next
    HRSOut CR,CR    

    '/
    '/ Write a Bit 0 command.
    HRSOut "Write a Bit 0 into the Array: Positions: 24,25,26,27",CR
    WriteArrayBit(MyArray1,24,0)
    HRSOut "Write a Bit: Index 24 = 0",CR 
    WriteArrayBit(MyArray1,25,0)
    HRSOut "Write a Bit: Index 25 = 0",CR
    WriteArrayBit(MyArray1,26,0)
    HRSOut "Write a Bit: Index 26 = 0",CR     
    WriteArrayBit(MyArray1,27,0)
    HRSOut "Write a Bit: Index 27 = 0",CR     

    HRSOut "Bits Array: %"
    '/ Print the array .
    For ByteLoop = MyArray1Lenght -1 To 0 Step - 1
        MyResultByte = MyArray1[ByteLoop] 
        HRSOut Bin8 MyResultByte," "
    Next
    HRSOut CR,CR    

    '/
    '/ Set a Bit command.
    HRSOut "Set a Bit into the Array: Positions: 24,25,26,27",CR
    SetArrayBit(MyArray1,24)
    HRSOut "Set a Bit: Index 24",CR 
    SetArrayBit(MyArray1,25)
    HRSOut "Set a Bit: Index 25",CR
    SetArrayBit(MyArray1,26)
    HRSOut "Set a Bit: Index 26",CR     
    SetArrayBit(MyArray1,27)
    HRSOut "Set a Bit: Index 27",CR     

    HRSOut "Bits Array: %"
    '/ Print the array .
    For ByteLoop = MyArray1Lenght -1 To 0 Step - 1
        MyResultByte = MyArray1[ByteLoop] 
        HRSOut Bin8 MyResultByte," "
    Next
    HRSOut CR,CR    

    '/ Clear a Bit command.
    HRSOut "Clear a Bit into the Array: Positions: 32,33,34,35",CR
    ClearArrayBit(MyArray1,32)
    HRSOut "Set a Bit: Index 32",CR 
    ClearArrayBit(MyArray1,33)
    HRSOut "Set a Bit: Index 33",CR
    ClearArrayBit(MyArray1,34)
    HRSOut "Set a Bit: Index 34",CR     
    ClearArrayBit(MyArray1,35)
    HRSOut "Set a Bit: Index 35",CR     

    HRSOut "Bits Array: %"
    '/ Print the array .
    For ByteLoop = MyArray1Lenght -1 To 0 Step - 1
        MyResultByte = MyArray1[ByteLoop] 
        HRSOut Bin8 MyResultByte," "
    Next
    HRSOut CR,CR
    HRSOut "END TEST",CR
'/------------------------------------------------------------------------------
    ENDSIZE(ARRAYBITS_CODE)
'/##############################################################################
    End
'/==============================================================================
  
