'****************************************************************
'*  Name    : Test_Tips_and_Tricks_ADD.BAS                      *
'*  Author  : [Alberto Freixanet]                               *
'*  Notice  : Copyright (c) 2018 [AFreixanet]                   *
'*          : All Rights Reserved                               *
'*  Date    : 29/09/2018                                        *
'*  Version : 1.0                                               *
'*  Notes   : Check the Addition command                        *
'*          :                                                   *
'****************************************************************
'/ Choose the include file depending of clock of ISIS CPU.
    Include "D:\MyIncFiles\proton18_16.inc"

    Declare Watchdog = OFF
'    Declare Float_Display_Type = Fast
'    Declare Float_Rounding = On             ' Round down to the nearest integer

'    Declare Reminders = Off
'    DECLARE LABEL_BANK_RESETS = ON
'    Declare Reminders = On
'    #define __INTERRUPTS_ENABLED 1


    Dim MyResultByte As Byte
    Dim MyResultWord As Word
    Dim MyResultDword As Dword
    Dim MyResultFloat As Float

    Dim MyInputByte As Byte
    Dim MyInputWord As Word
    Dim MyInputDword As Dword            
    Dim MyInputFloat As Float

    Dim WordLoop As Word
    Dim ByteLoop As Byte

'/ Place the String at the End of the Dim list

'/==============================================================================
'/ UARTs
'    $define _HRSOutTwoStopBitsInc_
' Others libraries.
'    $define _ADCaverageA_
'    $define _ADCaverageB_    
'    $define _CountUntil_
'    $define _HEXtoASCII_
'    $define _IDLOCS_
'    $define _HRSLStrg_
'    $define _DegC_DegF_
'    $define _Map8_
'    $define _Map16_
'    $define _MapF_    
'    $define _GIE_Save_
'    $define _DEVID1_
'    $define _StringToFloat_
'    $define _DebounceByte_    
'    $define _MyRandom_
'    $define _GrayCode_

    $define NumberBCDCounters 10
    $define _BCDCounters_

    $define __MEASURE_CODE_
'/------------------------------------------------------------------------------
    '/ Create your own path in the Hard disk D:\MyIncFiles. 
    Include "D:\MyIncFiles\TIPS_AND_TRICKS_V16.Inc"
'/==============================================================================
    GoTo OverMacros                              ' Jump over the subroutines
'/==============================================================================


'/==============================================================================
OverMacros:
'/==============================================================================
                      
'/###############################################################################
'/ Main Demo Program
'/ Use the ISIS program to test the code.
'/ Click the ISIS button in the toolbar and choose the PIC18_ALCD_VHB.DSN board with normal LCD. 
'/###############################################################################
    Cls
MAIN:
'/------------------------------------------------------------------------------
    Clear BCDArray1
    '/ Loading a value into the BCD counters
    BCDArray1#0 = 4
    BCDArray1#1 = 5    
    BCDArray1#2 = 6
    BCDArray1#3 = 9
    BCDArray1#4 = 7
    BCDArray1#5 = 8    
    BCDArray1#6 = 7  
    BCDArray1#7 = 0
    BCDArray1#8 = 0    
    BCDArray1#9 = 0 

    Clear BCDArray2
    '/ Loading a value into the BCD counters
    BCDArray2#0 = 6
    BCDArray2#1 = 5    
    BCDArray2#2 = 8
    BCDArray2#3 = 4
    BCDArray2#4 = 8
    BCDArray2#5 = 6
    BCDArray2#6 = 1
    BCDArray2#7 = 0
    BCDArray2#8 = 0
    BCDArray2#9 = 0
       
    HRSOut "ADDITION OF BCD COUNTERS :",CR
    HRSOut "NUMBER OF COUNTERS: ",Dec __VBCD_CounterLenght, CR, CR

    HRSOut "Counter1 Init:   " 
    HRSOut_BCDarray(1,$F1)      '/ Print all zeros.

    HRSOut "(+) Counter2:    " 
    HRSOut_BCDarray(2,$F1)      '/ Print all zeros.

    '/ Array1 + Array2 = Result (Array3)
    MyResultByte = ADD_BCD(1,2,3)

    If MyResultByte > 0 Then 
       HRSOut "OVERFLOW: MORE DIGITS ARE NEEDED!",CR,CR 
    EndIf 

    HRSOut "Counter3 Result: " 
    HRSOut_BCDarray(3,$F2)      '/ Print all zeros.

    '/ Check the arrays
    HRSOut "Check Array1: " 
    HRSOut_BCDarray(1,$F1)
    HRSOut "Check Array2: " 
    HRSOut_BCDarray(2,$F1)
    HRSOut "Check Array3: " 
    HRSOut_BCDarray(3,$F3) 

'/------------------------------------------------------------------------------
    '/ Convert a Byte to BCD Array (into Dword)
    MyInputByte = 189
    HRSOut "Convert a Byte to BCD Array: ",CR 
    HRSOut "MyInputByte: ", Dec MyInputByte,CR 

    '/ Using the Array number 3.
    STR_BCDArray(3, MyInputByte)

    HRSOut "Counter3 Result: " 
    HRSOut_BCDarray(3,$F2)      '/ Print all zeros.


    '/ Convert a Word to BCD Array
    MyInputWord = 31568
    HRSOut "Convert a Word to BCD Array: ",CR 
    HRSOut "MyInputWord: ", Dec MyInputWord,CR 

    '/ Using the Array number 2.
    STR_BCDArray(2, MyInputWord)

    HRSOut "Counter2 Result: " 
    HRSOut_BCDarray(2,$F2)      '/ Print all zeros.


    '/ Convert a Dword to BCD Array (into Word)
    MyInputDword = 82365789
    HRSOut "Convert a Dword to BCD Array: ",CR 
    HRSOut "MyInputDword: ", Dec MyInputDword,CR 

    '/ Using the Array number 1.
    STR_BCDArray(1, MyInputDword)

    HRSOut "Counter1 Result: " 
    HRSOut_BCDarray(1,$F3)      '/ Print all zeros.    

'/------------------------------------------------------------------------------
    Clear BCDArray1
    '/ Loading a value into the BCD counters
    BCDArray1#0 = 4
    BCDArray1#1 = 5    
    BCDArray1#2 = 6
    BCDArray1#3 = 9
    BCDArray1#4 = 7
    BCDArray1#5 = 8    
    BCDArray1#6 = 7  
    BCDArray1#7 = 0
    BCDArray1#8 = 0    
    BCDArray1#9 = 0 

    Clear BCDArray2
    '/ Loading a value into the BCD counters
    BCDArray2#0 = 6
    BCDArray2#1 = 5    
    BCDArray2#2 = 8
    BCDArray2#3 = 4
    BCDArray2#4 = 8
    BCDArray2#5 = 6
    BCDArray2#6 = 1
    BCDArray2#7 = 0
    BCDArray2#8 = 0
    BCDArray2#9 = 0

    Clear BCDArray3
    '/ Loading a value into the BCD counters
    BCDArray3#0 = 1
    BCDArray3#1 = 4    
    BCDArray3#2 = 9
    BCDArray3#3 = 8
    BCDArray3#4 = 5
    BCDArray3#5 = 8
    BCDArray3#6 = 4
    BCDArray3#7 = 0
    BCDArray3#8 = 0
    BCDArray3#9 = 0
        
    HRSOut "ADDITION OF BCD COUNTERS :",CR
    HRSOut "NUMBER OF COUNTERS: ",Dec __VBCD_CounterLenght, CR, CR

    HRSOut "Counter3 Init:   " 
    HRSOut_BCDarray(3,$F1)      '/ Print all zeros.
 

    HRSOut "(+) Counter1:    " 
    HRSOut_BCDarray(1,$F1)      '/ Print all zeros.

    '/ Array3 + Array1 = Array4
    MyResultByte = ADD_BCD(3,1,4)

    If MyResultByte > 0 Then 
       HRSOut "OVERFLOW: MORE DIGITS ARE NEEDED!",CR,CR 
    EndIf 

    HRSOut "Counter4 Result: " 
    HRSOut_BCDarray(4,$F1)      '/ Print all zeros.
    HRSOut "Counter4 Result: " 
    HRSOut_BCDarray(4,0)        '/ Print NO zero.    
    HRSOut "  Without zeros",CR 
    
    '/ Print the BCD array to the LCD.
    Print_BCDarray(3,1,1)       '/ Print NO zero.
    Print_BCDarray(3,2,$F1)     '/ Print all zeros.    
    HRSOut CR    

    '/ Check the arrays
    HRSOut "Check Array3: " 
    HRSOut_BCDarray(3,$F1)
    HRSOut "Check Array1: " 
    HRSOut_BCDarray(1,$F1)
    HRSOut "Check Array4: " 
    HRSOut_BCDarray(4,$F3) 

    HRSOut "SEE LCD...",CR
    DelayMS 3000
'/------------------------------------------------------------------------------
    Clear BCDArray1
    '/ Loading a value into the BCD counters
    BCDArray1#0 = 4
    BCDArray1#1 = 5    
    BCDArray1#2 = 6
    BCDArray1#3 = 9
    BCDArray1#4 = 7
    BCDArray1#5 = 8    
    BCDArray1#6 = 7  
    BCDArray1#7 = 2
    BCDArray1#8 = 7    
    BCDArray1#9 = 8 

    Clear BCDArray2
    '/ Loading a value into the BCD counters
    BCDArray2#0 = 6
    BCDArray2#1 = 5    
    BCDArray2#2 = 8
    BCDArray2#3 = 4
    BCDArray2#4 = 8
    BCDArray2#5 = 6
    BCDArray2#6 = 1
    BCDArray2#7 = 0
    BCDArray2#8 = 0
    BCDArray2#9 = 0

    Clear BCDArray3
    '/ Loading a value into the BCD counters
    BCDArray3#0 = 1
    BCDArray3#1 = 4    
    BCDArray3#2 = 9
    BCDArray3#3 = 8
    BCDArray3#4 = 5
    BCDArray3#5 = 8
    BCDArray3#6 = 4
    BCDArray3#7 = 6
    BCDArray3#8 = 5
    BCDArray3#9 = 1
        
    HRSOut "ADDITION OF BCD COUNTERS :",CR
    HRSOut "NUMBER OF COUNTERS: ",Dec __VBCD_CounterLenght, CR, CR

    HRSOut "Counter3 Init:   " 
    HRSOut_BCDarray(3,$F1)      '/ Print all zeros.
 

    HRSOut "(+) Counter1:    " 
    HRSOut_BCDarray(1,$F1)      '/ Print all zeros.

    '/ Array3 + Array1 = Array4
    MyResultByte = ADD_BCD(3,1,4)

    If MyResultByte > 0 Then 
        HRSOut "OVERFLOW: MORE DIGITS ARE NEEDED!",CR,CR 
    EndIf 

    HRSOut "Counter4 Result: " 
    HRSOut_BCDarray(4,$F1)      '/ Print all zeros.
    HRSOut "Counter4 Result: " 
    HRSOut_BCDarray(4,0)        '/ Print NO zero.    
    HRSOut "  Without zeros",CR 
    
    '/ Print the BCD array to the LCD.
    Print_BCDarray(3,1,1)       '/ Print NO zero.
    Print_BCDarray(3,2,$F1)     '/ Print all zeros.    
    HRSOut CR    

    '/ Check the arrays
    HRSOut "Check Array3: " 
    HRSOut_BCDarray(3,$F1)
    HRSOut "Check Array1: " 
    HRSOut_BCDarray(1,$F1)
    HRSOut "Check Array4: " 
    HRSOut_BCDarray(4,$F2) 

    HRSOut "SEE LCD...",CR

    HRSOut "END TEST: ",CR 

Stop

'/##############################################################################
    End
'/==============================================================================
 
