'****************************************************************
'*  Name    : Test_Tips_and_Tricks_ConvertArray.BAS             *
'*  Author  : [Alberto Freixanet]                               *
'*  Notice  : Copyright (c) 2018 [AFreixanet]                   *
'*          : All Rights Reserved                               *
'*  Date    : 29/08/2018                                        *
'*  Version : 1.0                                               *
'*  Notes   : Testing Convert Array to Variable                 *
'*          :                                                   *
'****************************************************************
'/ Choose the include file depending of clock of ISIS CPU.
    Include "D:\MyIncFiles\proton18_16.inc"

    Declare Watchdog = OFF
'    Declare Float_Display_Type = Fast
'    Declare Float_Rounding = On             ' Round down to the nearest integer

'    Declare Reminders = Off
'    DECLARE LABEL_BANK_RESETS = ON
'    Declare Reminders = On
'    #define __INTERRUPTS_ENABLED 1

    Dim MyResultByte As Byte
    Dim MyResultWord As Word
    Dim MyResultDword As Dword
    Dim MyResultFloat As Float

    Dim MyInputByte As Byte
    Dim MyInputWord As Word
    Dim MyInputDword As Dword            
    Dim MyInputFloat As Float

    Dim WordLoop As Word
    Dim ByteLoop As Byte

' Place the String at the End of the Dim list

'/==============================================================================
'/ UARTs
'    $define _HRSOutTwoStopBitsInc_
' Others libraries.
'    $define _ADCaverageA_
'    $define _ADCaverageB_    
'    $define _CountUntil_
'    $define _HEXtoASCII_
'    $define _IDLOCS_
'    $define _HRSLStrg_
'    $define _DegC_DegF_
'    $define _Map8_
'    $define _Map16_
'    $define _MapF_    
'    $define _GIE_Save_
'    $define _DEVID1_
'    $define _StringToFloat_
'    $define _DebounceByte_    
'    $define _MyRandom_
'    $define _GrayCode_

    $define NumberBCDCounters 15
    $define _BCDCounters_

    $define __MEASURE_CODE_
'/------------------------------------------------------------------------------
    '/ Create your own path in the Hard disk D:\MyIncFiles. 
    Include "D:\MyIncFiles\TIPS_AND_TRICKS_V16.Inc"
'/==============================================================================
    GoTo OverMacros                              ' Jump over the subroutines
'/==============================================================================


'/==============================================================================
OverMacros:
'/==============================================================================
                      
'/###############################################################################
'/ Main Demo Program
'/ Use the ISIS program to test the code.
'/ Click the ISIS button in the toolbar and choose the PIC18_ALCD_VHB.DSN board with normal LCD. 
'/###############################################################################
    Cls
MAIN:
'/------------------------------------------------------------------------------
    Clear BCDArray1
    '/ Loading a value into the BCD counters
    BCDArray1#0 = 5
    BCDArray1#1 = 7    
    BCDArray1#2 = 1
    BCDArray1#3 = 0
    BCDArray1#4 = 0
    BCDArray1#5 = 0    
    BCDArray1#6 = 0  
    BCDArray1#7 = 0
    BCDArray1#8 = 0    
    BCDArray1#9 = 0 
        
    HRSOut "BCD COUNTERS : VAL_BCDArray(Number) Command",CR
    HRSOut "NUMBER OF COUNTERS: ",Dec __VBCD_CounterLenght, CR, CR

    '/ Convert a BCD Array to a Byte 
    HRSOut "Convert a BCD Array to a Byte: ",CR 

    HRSOut "VAL Array: "
    '/ Using the Array number 1.
    HRSOut_BCDarray(1,$F2)          '/ Send all zeros.

    Print_BCDarray(1,1,$F1)         '/ Print all zeros to the LCD.

    MyResultByte = VAL_BCDArray(1)

    HRSOut "My Byte variable: ", Dec MyResultByte,CR
    Print At 2,1,Dec MyResultByte
    
    HRSOut "SEE LCD...",CR,CR
    HRSOut "More... ",CR,CR     
    '/--------------------------------------------------------------------------
    DelayMS 3000
    '/ Loading a value into the BCD counters
    BCDArray1#0 = 5  ' x1
    BCDArray1#1 = 9  ' x10  
    BCDArray1#2 = 7  ' x100
    BCDArray1#3 = 6  ' x100
    BCDArray1#4 = 4  ' x1000
    BCDArray1#5 = 0  ' x10000  
    BCDArray1#6 = 0  ' x100000
    BCDArray1#7 = 0  ' x1000000
    BCDArray1#8 = 0  ' x10000000  
    BCDArray1#9 = 0  ' x100000000
    
    '/ Convert a Full DwWord to BCD Array  
    HRSOut "Convert a Full Dword To BCD Array: ",CR 
 
    MyResultDword = $FFFFFFFF
    HRSOut "MyResultDword: ", Dec MyResultDword,CR

    HRSOut "STR Array:     "
    '/ Using the Array number 1.
    STR_BCDArray(1, MyResultDword)
    HRSOut_BCDarray(1,$F2)          '/ Send all zeros.

    '/ Convert a BCD Array to a Word 
    HRSOut "Convert a BCD Array to a Dword: ",CR 

    HRSOut "VAL Array: "
    '/ Using the Array number 1.
    HRSOut_BCDarray(1,$F2)          '/ Send all zeros.

    Print_BCDarray(1,1,$F1)         '/ Print all zeros to the LCD.

    MyResultDword = VAL_BCDArray(1)

    HRSOut "MyDword:   ", Dec MyResultDword,CR
    Print At 2,1,Dec MyResultDword     

    HRSOut "SEE LCD...",CR,CR
    HRSOut "More... ",CR,CR 

    '/--------------------------------------------------------------------------
    DelayMS 3000
    '/ Loading a value into the BCD counters
    BCDArray1#0 = 5  ' x1
    BCDArray1#1 = 9  ' x10  
    BCDArray1#2 = 7  ' x100
    BCDArray1#3 = 6  ' x100
    BCDArray1#4 = 4  ' x1000
    BCDArray1#5 = 0  ' x10000  
    BCDArray1#6 = 0  ' x100000
    BCDArray1#7 = 0  ' x1000000
    BCDArray1#8 = 0  ' x10000000  
    BCDArray1#9 = 0  ' x100000000
    
    '/ Convert a BCD Array to a Word 
    HRSOut "Convert a BCD Array to a Word: ",CR 

    HRSOut "VAL Array: "
    '/ Using the Array number 1.
    HRSOut_BCDarray(1,$F2)          '/ Send all zeros.

    Print_BCDarray(1,1,$F1)         '/ Print all zeros to the LCD.

    MyResultWord = VAL_BCDArray(1)

    HRSOut "My Word variable: ", Dec MyResultWord,CR
    Print At 2,1,Dec MyResultWord     

    HRSOut "SEE LCD...",CR,CR
    HRSOut "More... ",CR,CR 
    '/--------------------------------------------------------------------------
    DelayMS 3000
    '/ Loading a value into the BCD counters
    BCDArray1#0 = 5  ' x1
    BCDArray1#1 = 4  ' x10  
    BCDArray1#2 = 7  ' x100
    BCDArray1#3 = 5  ' x100
    BCDArray1#4 = 4  ' x1000
    BCDArray1#5 = 1  ' x10000  
    BCDArray1#6 = 6  ' x100000
    BCDArray1#7 = 5  ' x1000000
    BCDArray1#8 = 8  ' x10000000  
    BCDArray1#9 = 0  ' x100000000
    
    '/ Convert a BCD Array to a Dword 
    HRSOut "Convert a BCD Array to a Dword: ",CR 

    HRSOut "VAL Array: "
    '/ Using the Array number 1.
    HRSOut_BCDarray(1,$F2)          '/ Send all zeros.

    Print_BCDarray(1,1,$F1)         '/ Print all zeros to the LCD.

    MyResultDword = VAL_BCDArray(1)

    HRSOut "My Dword variable: ", Dec MyResultDword,CR
    Print At 2,1,Dec MyResultDword   

    HRSOut "SEE LCD...",CR,CR

    HRSOut "END TEST",CR
         
Stop

'/##############################################################################
    End
'/==============================================================================
 
