'****************************************************************
'*  Name    : Test_Tips_and_Tricks_DIV.BAS                      *
'*  Author  : [Alberto Freixanet]                               *
'*  Notice  : Copyright (c) 2018 [AFreixanet]                   *
'*          : All Rights Reserved                               *
'*  Date    : 29/09/2018                                        *
'*  Version : 1.0                                               *
'*  Notes   : Testing the Division BCD counters command         *
'*          : DIV command                                       *
'****************************************************************
'/ Choose the include file depending of clock of ISIS CPU.
    Include "D:\MyIncFiles\proton18_16.inc"

    Declare Watchdog = OFF
'    Declare Float_Display_Type = Fast
'    Declare Float_Rounding = On             ' Round down to the nearest integer

'    Declare Reminders = Off
'    DECLARE LABEL_BANK_RESETS = ON
'    Declare Reminders = On
'    #define __INTERRUPTS_ENABLED 1

    Dim MyResultByte As Byte
    Dim MyResultWord As Word
    Dim MyResultDword As Dword

    Dim MyInputByte As Byte
    Dim MyInputWord As Word
    Dim MyInputDword As Dword            

    Dim LoopByte As Byte
    Dim ErrorByte As Byte

' Place the String at the End of the Dim list

'/==============================================================================
'/ UARTs
'    $define _HRSOutTwoStopBitsInc_
' Others libraries.
'    $define _ADCaverageA_
'    $define _ADCaverageB_    
'    $define _CountUntil_
'    $define _HEXtoASCII_
'    $define _IDLOCS_
'    $define _HRSLStrg_
'    $define _DegC_DegF_
'    $define _Map8_
'    $define _Map16_
'    $define _MapF_    
'    $define _GIE_Save_
'    $define _DEVID1_
'    $define _StringToFloat_
'    $define _DebounceByte_    
'    $define _MyRandom_
'    $define _GrayCode_
'    $define _LENArray_

    $define NumberBCDCounters 15
    $define _BCDCounters_

    $define __MEASURE_CODE_
'/------------------------------------------------------------------------------
    '/ Create your own path in the Hard disk D:\MyIncFiles. 
    Include "D:\MyIncFiles\TIPS_AND_TRICKS_V16.Inc"
'/==============================================================================
    GoTo OverMacros                              ' Jump over the subroutines
'/==============================================================================


'/==============================================================================
OverMacros:
'/==============================================================================
                      
'/###############################################################################
'/ Main Demo Program
'/ Use the ISIS program to test the code.
'/ Click the ISIS button in the toolbar and choose the PIC18_ALCD_VHB.DSN board with normal LCD. 
'/###############################################################################
    Cls
MAIN:
    WDTCONBits_SWDTEN = 0   '/ Watchdog disabled por software.
    Low LATC.0
    Low LATC.2        
'/------------------------------------------------------------------------------
    HRSOut "DIVISION OF BCD COUNTERS: DIVV COMMAND:",CR
    HRSOut "NUMBER OF COUNTERS: ",Dec __VBCD_CounterLenght,CR
    HRSOut "TEST1: ",CR, CR
'    Delayms 4000
    
'    Clear BCDArray1
'    '/ Loading a value into the BCD counters
'    BCDArray1#0 = 4
'    BCDArray1#1 = 2    
'    BCDArray1#2 = 9
'    BCDArray1#3 = 8
'    BCDArray1#4 = 6
'    BCDArray1#5 = 7    
'    BCDArray1#6 = 0  
'    BCDArray1#7 = 0
'    BCDArray1#8 = 0    
'    BCDArray1#9 = 0 

'    Clear BCDArray2
'    '/ Loading a value into the BCD counters
'    BCDArray2#0 = 5
'    BCDArray2#1 = 4    
'    BCDArray2#2 = 1
'    BCDArray2#3 = 0
'    BCDArray2#4 = 0
'    BCDArray2#5 = 0
'    BCDArray2#6 = 0
'    BCDArray2#8 = 0
'    BCDArray2#9 = 0

    Clear BCDArray1
    '/ Loading a value into the BCD counters
    BCDArray1#0 = 4
    BCDArray1#1 = 2    
    BCDArray1#2 = 9
    BCDArray1#3 = 5
    BCDArray1#4 = 2
    BCDArray1#5 = 1    
    BCDArray1#6 = 2  
    BCDArray1#7 = 1
    BCDArray1#8 = 0    
    BCDArray1#9 = 0 
    BCDArray1#10 = 0  
    BCDArray1#11 = 0
    BCDArray1#12 = 0    
    BCDArray1#13 = 0 
    
    Clear BCDArray2
    '/ Loading a value into the BCD counters
'    BCDArray2#0 = 5
'    BCDArray2#1 = 4    
'    BCDArray2#2 = 1
'    BCDArray2#3 = 0
'    BCDArray2#4 = 0
'    BCDArray2#5 = 0
'    BCDArray2#6 = 0
'    BCDArray2#8 = 0
'    BCDArray2#9 = 0
'    BCDArray2#10 = 0
'    BCDArray2#11 = 0
'    BCDArray2#12 = 0
'    BCDArray2#13 = 0

    STR_BCDArray(2,145)   '/ Loading value 145 into the BCDArray2.
    
    HRSOut "DIVIDEND:  " 
    HRSOut_BCDarray(1,$F0)
    HRSOut "  DIVISOR: " 
    HRSOut_BCDarray(2,1)

    '/ Prm1 = Dividend  (Array nb1)
    '/ Prm2 = Divisor   (Array nb2)
    '/ Prm3 = Quotient  (Array nb3)
    '/        Remainder (Array nb4)        
    '/                   Dividend = 1 / Divisor = 2 = Quotient = 3
    Set LATC.0
    ErrorByte = DIV_BCD(1,2,3)
    Clear LATC.0

    If ErrorByte > 0 Then 
        HRSOut "OVERFLOW",CR,CR 
    EndIf 

    '/ Check the arrays
    HRSOut "Array1 Dividend:  " 
    HRSOut_BCDarray(1,1)
    HRSOut "Array2 Divisor:   " 
    HRSOut_BCDarray(2,1)
    HRSOut "Array3 Quotient:  "
    HRSOut_BCDarray(3,1)
    HRSOut "Array5 Remainder: "
    HRSOut_BCDarray(5,1)
    HRSOut "VAL Array3 Quotient: "
    MyResultDword = VAL_BCDArray(3)
    HRSOut Dec MyResultDword,CR,CR,CR
'/==============================================================================
    HRSOut "NUMBER OF COUNTERS: ",Dec __VBCD_CounterLenght,CR
    HRSOut "TEST2: ",CR, CR
'    Delayms 4000
    
    Clear BCDArray1
    '/ Loading a value into the BCD counters
    BCDArray1#0 = 5
    BCDArray1#1 = 2    
    BCDArray1#2 = 9
    BCDArray1#3 = 8
    BCDArray1#4 = 6
    BCDArray1#5 = 7    
    BCDArray1#6 = 9  
    BCDArray1#7 = 1
    BCDArray1#8 = 2    
    BCDArray1#9 = 5 

    Clear BCDArray2
    '/ Loading a value into the BCD counters
'    BCDArray2#0 = 2
'    BCDArray2#1 = 0    
'    BCDArray2#2 = 0
'    BCDArray2#3 = 0
'    BCDArray2#4 = 0
'    BCDArray2#5 = 0
'    BCDArray2#6 = 0
'    BCDArray2#7 = 0
'    BCDArray2#8 = 0
'    BCDArray2#9 = 0
        
    STR_BCDArray(2,2)   '/ Loading value 2 into the BCDArray2.

    HRSOut "DIVIDEND:  " 
    HRSOut_BCDarray(1,$F0)
    HRSOut "  DIVISOR: " 
    HRSOut_BCDarray(2,1)

    '/ Prm1 = Dividend  (Array nb1)
    '/ Prm2 = Divisor   (Array nb2)
    '/ Prm3 = Quotient  (Array nb3)
    '/        Remainder (Array nb4)        
    '/                   Dividend = 1 / Divisor = 2 = Quotient = 3
    Set LATC.0
    ErrorByte = DIV_BCD(1,2,3)
    Clear LATC.0

    If ErrorByte > 0 Then 
        HRSOut "OVERFLOW",CR,CR 
    EndIf 

    '/ Check the arrays
    HRSOut "Array1 Dividend:  " 
    HRSOut_BCDarray(1,1)
    HRSOut "Array2 Divisor:   " 
    HRSOut_BCDarray(2,1)
    HRSOut "Array3 Quotient:  "
    HRSOut_BCDarray(3,1)
    HRSOut "Array5 Remainder: "
    HRSOut_BCDarray(5,3)
'/==============================================================================
    HRSOut "NUMBER OF COUNTERS: ",Dec __VBCD_CounterLenght,CR
    HRSOut "TEST3: ",CR, CR
'    Delayms 4000
    
    Clear BCDArray1
    '/ Loading a value into the BCD counters
    BCDArray1#0 = 5
    BCDArray1#1 = 2    
    BCDArray1#2 = 9
    BCDArray1#3 = 8
    BCDArray1#4 = 6
    BCDArray1#5 = 7    
    BCDArray1#6 = 9  
    BCDArray1#7 = 1
    BCDArray1#8 = 2    
    BCDArray1#9 = 5 
    BCDArray1#10 = 1
    BCDArray1#11 = 3    
    BCDArray1#12 = 4
    BCDArray1#13 = 5
    BCDArray1#14 = 0    

    Clear BCDArray2
    '/ Loading a value into the BCD counters
    BCDArray2#0 = 2
    BCDArray2#1 = 3    
    BCDArray2#2 = 8
    BCDArray2#3 = 6
    BCDArray2#4 = 4
    BCDArray2#5 = 0
    BCDArray2#6 = 0
    BCDArray2#7 = 0
    BCDArray2#8 = 0
    BCDArray2#9 = 0
    BCDArray2#10 = 0
    BCDArray2#11 = 0
    BCDArray2#12 = 0
    BCDArray2#13 = 0
    BCDArray2#13 = 0
    
'    Clear BCDArray1
'    '/ Loading a value into the BCD counters
'    BCDArray1#0 = 0
'    BCDArray1#1 = 0    
'    BCDArray1#2 = 2
'    BCDArray1#3 = 4
'    BCDArray1#4 = 3
'    BCDArray1#5 = 0    
'    BCDArray1#6 = 0  
'    BCDArray1#7 = 0
'    BCDArray1#8 = 0    
'    BCDArray1#9 = 0 

'    Clear BCDArray2
'    '/ Loading a value into the BCD counters
'    BCDArray2#0 = 5
'    BCDArray2#1 = 4    
'    BCDArray2#2 = 0
'    BCDArray2#3 = 0
'    BCDArray2#4 = 0
'    BCDArray2#5 = 0
'    BCDArray2#6 = 0
'    BCDArray2#7 = 0
'    BCDArray2#8 = 0
        
    HRSOut "DIVIDEND:  " 
    HRSOut_BCDarray(1,$F0)
    HRSOut "  DIVISOR: " 
    HRSOut_BCDarray(2,1)

    '/ Prm1 = Dividend  (Array nb1)
    '/ Prm2 = Divisor   (Array nb2)
    '/ Prm3 = Quotient  (Array nb3)
    '/        Remainder (Array nb4)        
    '/                   Dividend = 1 / Divisor = 2 = Quotient = 3
    Set LATC.0
    ErrorByte = DIV_BCD(1,2,3)
    Clear LATC.0

    If ErrorByte > 0 Then 
        HRSOut "OVERFLOW",CR,CR 
    EndIf 

    '/ Check the arrays
    HRSOut "Array1 Dividend:  " 
    HRSOut_BCDarray(1,1)
    HRSOut "Array2 Divisor:   " 
    HRSOut_BCDarray(2,1)
    HRSOut "Array3 Quotient:  "
    HRSOut_BCDarray(3,1)
    HRSOut "Array5 Remainder: "
    HRSOut_BCDarray(5,3)
'/==============================================================================
    HRSOut "NUMBER OF COUNTERS: ",Dec __VBCD_CounterLenght,CR
    HRSOut "TEST4: ",CR,CR
'    Delayms 4000
    
    Clear BCDArray1
    '/ Loading a value into the BCD counters
    BCDArray1#0 = 0
    BCDArray1#1 = 0    
    BCDArray1#2 = 2
    BCDArray1#3 = 4
    BCDArray1#4 = 3
    BCDArray1#5 = 0    
    BCDArray1#6 = 0  
    BCDArray1#7 = 0
    BCDArray1#8 = 0    
    BCDArray1#9 = 0 

    Clear BCDArray2
'    '/ Loading a value into the BCD counters
'    BCDArray2#0 = 5
'    BCDArray2#1 = 4    
'    BCDArray2#2 = 0
'    BCDArray2#3 = 0
'    BCDArray2#4 = 0
'    BCDArray2#5 = 0
'    BCDArray2#6 = 0
'    BCDArray2#7 = 0
'    BCDArray2#8 = 0

    STR_BCDArray(2,45)
    
    HRSOut "DIVIDEND:  " 
    HRSOut_BCDarray(1,$F0)
    HRSOut "  DIVISOR: " 
    HRSOut_BCDarray(2,1)

    '/ Prm1 = Dividend  (Array nb1)
    '/ Prm2 = Divisor   (Array nb2)
    '/ Prm3 = Quotient  (Array nb3)
    '/        Remainder (Array nb4)        
    '/                   Dividend = 1 / Divisor = 2 = Quotient = 3
    Set LATC.0
    ErrorByte = DIV_BCD(1,2,3)
    Clear LATC.0

    If ErrorByte > 0 Then 
        HRSOut "OVERFLOW",CR,CR 
    EndIf 

    '/ Check the arrays
    HRSOut "Array1 Dividend:  " 
    HRSOut_BCDarray(1,1)
    HRSOut "Array2 Divisor:   " 
    HRSOut_BCDarray(2,1)
    HRSOut "Array3 Quotient:  "
    HRSOut_BCDarray(3,1)
    HRSOut "Array5 Remainder: "
    HRSOut_BCDarray(5,3)
'/==============================================================================
    HRSOut "NUMBER OF COUNTERS: ",Dec __VBCD_CounterLenght,CR
    HRSOut "TEST5: ",CR,CR
'    Delayms 4000
    
    Clear BCDArray2
    '/ Loading a value into the BCD counters
'    BCDArray2#0 = 0
'    BCDArray2#1 = 1    
'    BCDArray2#2 = 0
'    BCDArray2#3 = 0
'    BCDArray2#4 = 0
'    BCDArray2#5 = 0
'    BCDArray2#6 = 0
'    BCDArray2#7 = 0
'    BCDArray2#8 = 0

    STR_BCDArray(2,10)
    
    HRSOut "DIVIDEND:  " 
    HRSOut_BCDarray(3,$F0)
    HRSOut "  DIVISOR: " 
    HRSOut_BCDarray(2,1)

    '/ Prm1 = Dividend  (Array nb3)
    '/ Prm2 = Divisor   (Array nb2)
    '/ Prm3 = Quotient  (Array nb1)
    '/        Remainder (Array nb4)        
    '/                   Dividend = 3 / Divisor = 2 = Quotient = 1
    Set LATC.0
    ErrorByte = DIV_BCD(3,2,1)
    Clear LATC.0

    If ErrorByte > 0 Then 
        HRSOut "OVERFLOW",CR,CR 
    EndIf 

    '/ Check the arrays
    HRSOut "Array3 Dividend:  " 
    HRSOut_BCDarray(3,1)
    HRSOut "Array2 Divisor:   " 
    HRSOut_BCDarray(2,1)
    HRSOut "Array1 Quotient:  "
    HRSOut_BCDarray(1,1)
    HRSOut "Array5 Remainder: "
    HRSOut_BCDarray(5,2)
'/==============================================================================

    HRSOut "END TEST",CR 

Stop
'/##############################################################################
    End
'/==============================================================================
 
