'****************************************************************
'*  Name    : Test_Tips_and_Tricks_General.BAS                  *
'*  Author  : [Alberto Freixanet]                               *
'*  Notice  : Copyright (c) 2018 [AFreixanet]                   *
'*          : All Rights Reserved                               *
'*  Date    : 29/09/2018                                        *
'*  Version : 1.0                                               *
'*  Notes   : Testing the N-Bit BCD MATHs                       *
'*          : With the Amicus18 Board                           *
'****************************************************************
'/ Choose the include file depending of clock of ISIS CPU.

'    $define PLL_ConfigFuses On

'    Include "D:\MyIncFiles\Amicus18_80_25K20.inc"
'    Include "D:\MyIncFiles\Amicus18_25K22.inc"
    Include "D:\MyIncFiles\proton18_16.inc"

    Declare Watchdog = OFF
'    Declare Float_Display_Type = Fast
'    Declare Float_Rounding = On             ' Round down to the nearest integer

'    Declare Reminders = Off
'    DECLARE LABEL_BANK_RESETS = ON
'    Declare Reminders = On
'    #define __INTERRUPTS_ENABLED 1
'    #define WatchDog_Req 1

    Dim MyResultByte As Byte
    Dim MyResultWord As Word
    Dim MyResultDword As Dword
    Dim MyResultFloat As Float

    Dim MyInputByte As Byte
    Dim MyInputWord As Word
    Dim MyInputDword As Dword            
    Dim MyInputFloat As Float

    Dim ErrorByte As Byte

' Place the String at the End of the Dim list


'/==============================================================================
'/ UARTs
'    $define _HRSOutTwoStopBitsInc_
' Others libraries.
'    $define _ADCaverageA_
'    $define _ADCaverageB_    
'    $define _CountUntil_
'    $define _HEXtoASCII_
'    $define _IDLOCS_
'    $define _HRSLStrg_
'    $define _DegC_DegF_
'    $define _Map8_
'    $define _Map16_
'    $define _MapF_    
'    $define _GIE_Save_
'    $define _DEVID1_
'    $define _StringToFloat_
'    $define _DebounceByte_    
'    $define _MyRandom_
'    $define _GrayCode_

    $define _LENArray_
    $define NumberBCDCounters 25
    $define _BCDCounters_

    $define __MEASURE_CODE_
'/------------------------------------------------------------------------------
    '/ Create your own path in the Hard disk D:\MyIncFiles. 
    Include "D:\MyIncFiles\TIPS_AND_TRICKS_V16.Inc"
'/==============================================================================
    GoTo OverMacros                              ' Jump over the subroutines
'/==============================================================================


'/==============================================================================
OverMacros:
'/==============================================================================
                      
'/###############################################################################
'/ Main Demo Program
'/ Use the ISIS program to test the code.
'/ Click the ISIS button in the toolbar and choose the PIC18_ALCD_VHB.DSN board with normal LCD. 
'/###############################################################################
    Cls
MAIN:
    Disable_SWDTEN()   '/ Watchdog disabled por software.
'/------------------------------------------------------------------------------
    HRSOut "CHECKING ALL COMMANDS:",CR
    HRSOut "NUMBER OF COUNTERS: ",Dec __VBCD_CounterLenght,CR,CR
    '/--------------------------------------------------------------------------
    '/ ADDITION:
    HRSOut "TEST 1: ",CR
    HRSOut "ADDITION:",CR

    Clear BCDArray1
    '/ Loading a value into the BCD counters
    BCDArray1#0 = 0
    BCDArray1#1 = 0    
    BCDArray1#2 = 0
    BCDArray1#3 = 0
    BCDArray1#4 = 0
    BCDArray1#5 = 0    
    BCDArray1#6 = 0 
    BCDArray1#7 = 0
    BCDArray1#8 = 1    
    BCDArray1#9 = 0 
    BCDArray1#10 = 0    
    BCDArray1#11 = 0

    Clear BCDArray2
    '/ Loading a value into the BCD counters
    BCDArray2#0 = 0
    BCDArray2#1 = 0    
    BCDArray2#2 = 1
    BCDArray2#3 = 4
    BCDArray2#4 = 2
    BCDArray2#5 = 6
    BCDArray2#6 = 5
    BCDArray2#8 = 0
    BCDArray2#9 = 0
    BCDArray2#10 = 0
    BCDArray2#11 = 0

    '/ Array1 + Array2 = Result (Array3)
    MyResultByte = ADD_BCD(1,2,3)

    If MyResultByte > 0 Then 
        HRSOut "OVERFLOW",CR,CR 
    EndIf 

    '/ Check the arrays
    HRSOut "INPUT:   " 
    HRSOut_BCDarray(1,1)
    HRSOut "ADD (+): " 
    HRSOut_BCDarray(2,1)
    HRSOut "RESULT:  " 
    HRSOut_BCDarray(3,3)
    '/--------------------------------------------------------------------------
    '/ MULTIPLICATION:
    HRSOut "NUMBER OF COUNTERS: ",Dec __VBCD_CounterLenght,CR
    HRSOut "TEST 2: ",CR
    HRSOut "MULTIPLICATION:",CR

    Clear BCDArray2
    '/ Loading a value into the BCD counters
    BCDArray2#0 = 0
    BCDArray2#1 = 0    
    BCDArray2#2 = 0
    BCDArray2#3 = 5
    BCDArray2#4 = 4
    BCDArray2#5 = 5
    BCDArray2#6 = 9
    BCDArray2#8 = 0
    BCDArray2#9 = 0
    BCDArray2#10 = 0
    BCDArray2#11 = 0

    '/ MULTIPLIER   => Array nb 3
    '/ MULTIPLICAND => Array nb 2
    '/ PRODUCT      => Array nb 1        
    ErrorByte = MUL_BCD(3,2,1)
    
    If ErrorByte > 0 Then 
        HRSOut "OVERFLOW",CR,CR 
    EndIf     

    '/ Check the arrays
    HRSOut "MULTIPLIER: " 
    HRSOut_BCDarray(3,1)
    HRSOut "MULT (X):   " 
    HRSOut_BCDarray(2,1)
    HRSOut "PRODUCT:    " 
    HRSOut_BCDarray(1,3)
    '/--------------------------------------------------------------------------     
    '/ DIVISION:
    HRSOut "NUMBER OF COUNTERS: ",Dec __VBCD_CounterLenght,CR
    HRSOut "TEST 3: ",CR
    HRSOut "DIVISION:",CR

    Clear BCDArray2
    '/ DIVISOR
    '/ Loading a value into the BCD counters
    BCDArray2#0 = 0
    BCDArray2#1 = 0    
    BCDArray2#2 = 0
    BCDArray2#3 = 5
    BCDArray2#4 = 4
    BCDArray2#5 = 5
    BCDArray2#6 = 9
    BCDArray2#8 = 0
    BCDArray2#9 = 0
    BCDArray2#10 = 0
    BCDArray2#11 = 0

    '/ Prm1 = DIVIDEND  (Array nb1)
    '/ Prm2 = DIVISOR   (Array nb2)
    '/ Prm3 = QUOTIENT  (Array nb3)
    '/        REMAINDER (Array nb4)        
    '/                   Dividend / Divisor = Quotient
    ErrorByte = DIV_BCD(1,2,3)

    If ErrorByte > 0 Then 
        HRSOut "OVERFLOW",CR,CR
    EndIf 

    '/ Check the arrays
    HRSOut "DIVIDENT:        " 
    HRSOut_BCDarray(1,1)
    HRSOut "DIV (/) DIVISOR: " 
    HRSOut_BCDarray(2,1)
    HRSOut "QUOTIENT:        " 
    HRSOut_BCDarray(3,1)
    HRSOut "RENAINDER:       " 
    HRSOut_BCDarray(4,3)

'/------------------------------------------------------------------------------
    '/ SUBTRACTION:
    HRSOut "NUMBER OF COUNTERS: ",Dec __VBCD_CounterLenght,CR
    HRSOut "TEST 4: ",CR
    HRSOut "SUBTRACTION:",CR

    Clear BCDArray2
    '/ Loading a value into the BCD counters
    BCDArray2#0 = 0
    BCDArray2#1 = 0    
    BCDArray2#2 = 1
    BCDArray2#3 = 4
    BCDArray2#4 = 2
    BCDArray2#5 = 6
    BCDArray2#6 = 5
    BCDArray2#8 = 0
    BCDArray2#9 = 0
    BCDArray2#10 = 0
    BCDArray2#11 = 0

           
    ErrorByte = SUB_BCD(3,2,1)

    If ErrorByte > 0 Then 
        HRSOut "OVERFLOW",CR,CR
    EndIf 

    '/ Check the arrays
    HRSOut "INPUT:   " 
    HRSOut_BCDarray(3,1)
    HRSOut "SUB (-): " 
    HRSOut_BCDarray(2,1)
    HRSOut "RESULT:  " 
    HRSOut_BCDarray(1,2)
'/------------------------------------------------------------------------------
    HRSOut "END TEST",CR  

Stop

'/##############################################################################
    End
'/==============================================================================
 
