'****************************************************************
'*  Name    : Test_Tips_and_Tricks_IncDec.BAS                   *
'*  Author  : [Alberto Freixanet]                               *
'*  Notice  : Copyright (c) 2018 [AFreixanet]                   *
'*          : All Rights Reserved                               *
'*  Date    : 29/09/2018                                        *
'*  Version : 1.0                                               *
'*  Notes   : Testing the Increment/Decrement BCD counters      *
'*          :                                                   *
'****************************************************************
'/ Choose the include file depending of clock of ISIS CPU.
    Include "D:\MyIncFiles\proton18_16.inc"

'    Declare Float_Display_Type = Fast
'    Declare Float_Rounding = On             ' Round down to the nearest integer
    Declare Watchdog = OFF

'    Declare Reminders = Off
'    DECLARE LABEL_BANK_RESETS = ON
'    Declare Reminders = On
'    #define __INTERRUPTS_ENABLED 1

    Dim MyResultByte As Byte
    Dim MyResultWord As Word
    Dim MyResultSWord As SWord    
    Dim MyResultDword As Dword
    Dim MyResultFloat As Float

    Dim MyResultRDword As Word

    Dim MyInputByte As Byte
    Dim MyInputWord As Word
    Dim MyInputDword As Dword            
    Dim MyInputFloat As Float

    Dim WordLoop As Word
    Dim ByteLoop As Byte

' Place the String at the End of the Dim list

'/==============================================================================
'/ UARTs
'    $define _HRSOutTwoStopBitsInc_
' Others libraries.
'    $define _ADCaverageA_
'    $define _ADCaverageB_    
'    $define _CountUntil_
'    $define _HEXtoASCII_
'    $define _IDLOCS_
'    $define _HRSLStrg_
'    $define _DegC_DegF_
'    $define _Map8_
'    $define _Map16_
'    $define _MapF_    
'    $define _GIE_Save_
'    $define _DEVID1_
'    $define _StringToFloat_
'    $define _DebounceByte_    
'    $define _MyRandom_
'    $define _GrayCode_

    $define NumberBCDCounters 10
    $define _BCDCounters_

    $define __MEASURE_CODE_
'/------------------------------------------------------------------------------
    '/ Create your own path in the Hard disk D:\MyIncFiles. 
    Include "D:\MyIncFiles\TIPS_AND_TRICKS_V16.Inc"
'/==============================================================================
    GoTo OverMacros                              ' Jump over the subroutines
'/==============================================================================


'/==============================================================================
OverMacros:
'/==============================================================================
                            
'/###############################################################################
'/ Main Demo Program
'/ Use the ISIS program to test the code.
'/ Click the ISIS button in the toolbar and choose the PIC18_ALCD_VHB.DSN board with normal LCD. 
'/###############################################################################
    Cls
MAIN:

'/------------------------------------------------------------------------------
    HRSOut "INCREMENT - DECREMENT BCD COUNTERs:",CR,CR
    
    HRSOut "NUMBER OF COUNTERS: ",Dec __VBCD_CounterLenght, CR, CR

    HRSOut "INCREMENT BCD COUNTER:",CR
    HRSOut "TEST 1:",CR,CR
INC_BCD:
    Clear BCDArray1

    '/ Testing increment BCD counters.
    For ByteLoop = 0 To 24
        IncBCD(1)               '/ Increment the BCD Counter array1
        HRSOut "Counter Inc: " 
        HRSOut_BCDarray(1,1)
    Next
    HRSOut CR
    
    '/ Testing decrement BCD counters.
    For ByteLoop = 0 To 24
        DecBCD(1)               '/ Increment the BCD Counter array1
        HRSOut "Counter Dec: " 
        HRSOut_BCDarray(1,1)
    Next
    HRSOut CR,CR    
'/------------------------------------------------------------------------------
    HRSOut "NUMBER OF COUNTERS: ",Dec __VBCD_CounterLenght,CR
    HRSOut "INCREMENT BCD COUNTER:",CR
    HRSOut "TEST 2:",CR,CR

    Clear BCDArray1

    '/ Testing increment BCD counters.
    For ByteLoop = 0 To 9
        IncBCD(1)               '/ Increment the BCD Counter array1
        HRSOut "Counter Inc: " 
        HRSOut_BCDarray(1,1)
    Next
    HRSOut CR
    
    '/ Testing decrement BCD counters.
    For ByteLoop = 0 To 20
        MyResultByte = DecBCD(1)               '/ Increment the BCD Counter array1
        HRSOut "Counter Dec: " 
        HRSOut_BCDarray(1,1)
        If MyResultByte > 0 Then
            HRSOut "OVERFLOW!",CR
            Break
        EndIf
    Next

    HRSOut CR,CR    

'/------------------------------------------------------------------------------
    HRSOut "NUMBER OF COUNTERS: ",Dec __VBCD_CounterLenght,CR
    HRSOut "DECREMENT BCD COUNTER:",CR
    HRSOut "TEST 3:",CR,CR

    Clear BCDArray1
    '/ Loading a value into the BCD counters
    BCDArray1#0 = 0
    BCDArray1#1 = 2    
    BCDArray1#2 = 1
    BCDArray1#3 = 5
    BCDArray1#4 = 7
    BCDArray1#5 = 0
    BCDArray1#6 = 0    
    BCDArray1#7 = 0
    BCDArray1#8 = 0
    BCDArray1#9 = 0
    
    HRSOut "Counter Init: " 
    HRSOut_BCDarray(1,$F1)      '/ Print all zeros.

DEC_BCD:
    '/ Testing decrement BCD counters.
    For ByteLoop = 0 To 39
        DecBCD(1)               '/ Decrement the BCD Counter array1
        HRSOut "Counter Decr: " 
        HRSOut_BCDarray(1,$F1)  '/ Print all zeros.
    Next
    HRSOut CR

    HRSOut "END TEST",CR 

'/##############################################################################
    End
'/==============================================================================
 
