'****************************************************************
'*  Name    : Test_Tips_and_Tricks_MUL.BAS                      *
'*  Author  : [Alberto Freixanet]                               *
'*  Notice  : Copyright (c) 2018 [AFreixanet]                   *
'*          : All Rights Reserved                               *
'*  Date    : 19/09/2018                                        *
'*  Version : 1.0                                               *
'*  Notes   : Testing the Multiplication BCD counters command   *
'*          : (MUL_BCD) MULTIPLICAND in an array                *
'****************************************************************
'/ Choose the include file depending of clock of ISIS CPU.
    Include "D:\MyIncFiles\proton18_16.inc"

    Declare Watchdog = OFF
'    Declare Float_Display_Type = Fast
'    Declare Float_Rounding = On             ' Round down to the nearest integer

'    Declare Reminders = Off
'    DECLARE LABEL_BANK_RESETS = ON
'    Declare Reminders = On
'    #define __INTERRUPTS_ENABLED 1

    Dim MyResultByte As Byte
    Dim MyResultWord As Word
    Dim MyResultSWord As SWord    
    Dim MyResultDword As Dword
    Dim MyResultFloat As Float
    Dim MyMultiplierWord As Word
    Dim MyMultiplierDword As Dword    
    Dim MyMultiplierByte As Byte

    Dim ErrorByte As Byte
    Dim MyInputByte As Byte
    Dim MyInputWord As Word
    Dim MyInputDword As Dword            
    Dim MyInputFloat As Float

    Dim WordLoop As Word
    Dim ByteLoop As Byte

' Place the String at the End of the Dim list

'/==============================================================================
'/ UARTs
'    $define _HRSOutTwoStopBitsInc_
' Others libraries.
'    $define _ADCaverageA_
'    $define _ADCaverageB_    
'    $define _CountUntil_
'    $define _HEXtoASCII_
'    $define _IDLOCS_
'    $define _HRSLStrg_
'    $define _DegC_DegF_
'    $define _Map8_
'    $define _Map16_
'    $define _MapF_    
'    $define _GIE_Save_
'    $define _DEVID1_
'    $define _StringToFloat_
'    $define _DebounceByte_    
'    $define _MyRandom_
'    $define _GrayCode_

    $define NumberBCDCounters 25
    $define _BCDCounters_

    $define __MEASURE_CODE_
'/------------------------------------------------------------------------------
    '/ Create your own path in the Hard disk D:\MyIncFiles. 
    Include "D:\MyIncFiles\TIPS_AND_TRICKS_V16.Inc"
'/==============================================================================
    GoTo OverMacros                              ' Jump over the subroutines
'/==============================================================================


'/==============================================================================
OverMacros:
'/==============================================================================
                      
'/###############################################################################
'/ Main Demo Program
'/ Use the ISIS program to test the code.
'/ Click the ISIS button in the toolbar and choose the PIC18_ALCD_VHB.DSN board with normal LCD. 
'/###############################################################################
    Cls
MAIN:
    Disable_SWDTEN()   '/ Watchdog disabled por software.
'/------------------------------------------------------------------------------
    HRSOut "MULTIPLICATION (MULA) WITH BCD COUNTERS BY AN ARRAY:",CR
    HRSOut "THE MULTIPLIER IS DESTROYED AFTER MULTIPLICATION: ",CR  

    HRSOut "NUMBER OF COUNTERS: ",Dec __VBCD_CounterLenght,CR
    HRSOut "TEST 1: ",CR,CR

    Clear BCDArray1 
    '/ Loading a value into the BCD counters
    BCDArray1#0 = 0
    BCDArray1#1 = 0    
    BCDArray1#2 = 0
    BCDArray1#3 = 0
    BCDArray1#4 = 5
    BCDArray1#5 = 2    
    BCDArray1#6 = 0  
    BCDArray1#7 = 0
    BCDArray1#8 = 0    
    BCDArray1#9 = 0 

    Clear BCDArray2 
    '/ Loading a value into the BCD counters
    BCDArray2#0 = 0
    BCDArray2#1 = 0    
    BCDArray2#2 = 0
    BCDArray2#3 = 5
    BCDArray2#4 = 1
    BCDArray2#5 = 0
    BCDArray2#6 = 0
    BCDArray2#8 = 0
    BCDArray2#9 = 0

    HRSOut "MULTIPLIER: " 
    HRSOut_BCDarray(1,0)
    HRSOut " X MULTIPLICAND: " 
    HRSOut_BCDarray(2,1)

    '/ MULTIPLIER   => Array nb 1
    '/ MULTIPLICAND => Array nb 2
    '/ PRODUCT      => Array nb 4        
    ErrorByte = MUL_BCD(1,2,4)

    If ErrorByte > 0 Then 
        HRSOut "OVERFLOW",CR,CR 
    EndIf 

    HRSOut "PRODUCT:    " 
    HRSOut_BCDarray(4,2)

    '/ Check the arrays
    HRSOut "Check Array1: " 
    HRSOut_BCDarray(1,1)
    HRSOut "Check Array2: " 
    HRSOut_BCDarray(2,1)
    HRSOut "Check Array4: " 
    HRSOut_BCDarray(4,3) 
   
'/------------------------------------------------------------------------------
    HRSOut "NUMBER OF COUNTERS: ",Dec __VBCD_CounterLenght,CR
    HRSOut "TEST 2: ",CR,CR

    Clear BCDArray1 
    '/ Loading a value into the BCD counters
    BCDArray1#0 = 0
    BCDArray1#1 = 7    
    BCDArray1#2 = 4
    BCDArray1#3 = 6
    BCDArray1#4 = 0
    BCDArray1#5 = 5    
    BCDArray1#6 = 2  
    BCDArray1#7 = 1
    BCDArray1#8 = 0    
    BCDArray1#9 = 0 

    Clear BCDArray2 
    '/ Loading a value into the BCD counters
    BCDArray2#0 = 0
    BCDArray2#1 = 6    
    BCDArray2#2 = 8
    BCDArray2#3 = 4
    BCDArray2#4 = 0
    BCDArray2#5 = 0
    BCDArray2#6 = 0
    BCDArray2#8 = 0
    BCDArray2#9 = 0

    Clear BCDArray3     
    '/ Loading a value into the BCD counters
    BCDArray3#0 = 1
    BCDArray3#1 = 4    
    BCDArray3#2 = 9
    BCDArray3#3 = 8
    BCDArray3#4 = 5
    BCDArray3#5 = 8
    BCDArray3#6 = 4
    BCDArray3#7 = 1
    BCDArray3#8 = 1
    BCDArray3#9 = 0
        
    HRSOut "NUMBER OF COUNTERS: ",Dec __VBCD_CounterLenght, CR, CR

    HRSOut "MULTIPLIER: " 
    HRSOut_BCDarray(1,0)
    HRSOut " X MULTIPLICAND: " 
    HRSOut_BCDarray(2,1)

    '/ MULTIPLIER   => Array nb 1
    '/ MULTIPLICAND => Array nb 2
    '/ PRODUCT      => Array nb 4        
    ErrorByte = MUL_BCD(1,2,4)

    If ErrorByte > 0 Then 
        HRSOut "OVERFLOW",CR,CR 
    EndIf 

    HRSOut "PRODUCT:    " 
    HRSOut_BCDarray(4,2)

    '/ Check the arrays
    HRSOut "Check Array1: " 
    HRSOut_BCDarray(1,1)
    HRSOut "Check Array2: " 
    HRSOut_BCDarray(2,1)
    HRSOut "Check Array4: " 
    HRSOut_BCDarray(4,3)
'/------------------------------------------------------------------------------
    HRSOut "NUMBER OF COUNTERS: ",Dec __VBCD_CounterLenght,CR
    HRSOut "TEST 3: ",CR,CR

    Clear BCDArray1 
    '/ Loading a value into the BCD counters
    BCDArray1#0 = 0
    BCDArray1#1 = 5    
    BCDArray1#2 = 5
    BCDArray1#3 = 0
    BCDArray1#4 = 1
    BCDArray1#5 = 5    
    BCDArray1#6 = 2  
    BCDArray1#7 = 5
    BCDArray1#8 = 4    
    BCDArray1#9 = 8 

    Clear BCDArray2 
    '/ Loading a value into the BCD counters
    BCDArray2#0 = 0
    BCDArray2#1 = 2    
    BCDArray2#2 = 5
    BCDArray2#3 = 6
    BCDArray2#4 = 4
    BCDArray2#5 = 8
    BCDArray2#6 = 2
    BCDArray2#8 = 0
    BCDArray2#9 = 0

    Clear BCDArray3     
    '/ Loading a value into the BCD counters
    BCDArray3#0 = 1
    BCDArray3#1 = 4    
    BCDArray3#2 = 9
    BCDArray3#3 = 8
    BCDArray3#4 = 5
    BCDArray3#5 = 8
    BCDArray3#6 = 4
    BCDArray3#7 = 1
    BCDArray3#8 = 1
    BCDArray3#9 = 0
        
    HRSOut "NUMBER OF COUNTERS: ",Dec __VBCD_CounterLenght, CR, CR

    HRSOut "MULTIPLIER: " 
    HRSOut_BCDarray(1,0)
    HRSOut " X MULTIPLICAND: " 
    HRSOut_BCDarray(2,1)

    '/ MULTIPLIER   => Array nb 1
    '/ MULTIPLICAND => Array nb 2
    '/ PRODUCT      => Array nb 3        
    ErrorByte = MUL_BCD(1,2,3)

    If ErrorByte > 0 Then 
        HRSOut "OVERFLOW",CR,CR 
    EndIf 

    HRSOut "PRODUCT:    " 
    HRSOut_BCDarray(3,2)

    '/ Restore the MULTIPLIER
    HRSOut "CHECK THE MULTIPLIER: " 
    HRSOut_BCDarray(1,2)

    '/ Check the arrays
    HRSOut "Check Array1: " 
    HRSOut_BCDarray(1,1)
    HRSOut "Check Array2: " 
    HRSOut_BCDarray(2,1)
    HRSOut "Check Array3: " 
    HRSOut_BCDarray(3,3)
'/------------------------------------------------------------------------------
    HRSOut "NUMBER OF COUNTERS: ",Dec __VBCD_CounterLenght,CR
    HRSOut "TEST 4: ",CR,CR

    Clear BCDArray1 
    '/ Loading a value into the BCD counters
    BCDArray1#0 = 0
    BCDArray1#1 = 0    
    BCDArray1#2 = 0
    BCDArray1#3 = 5
    BCDArray1#4 = 0
    BCDArray1#5 = 0    
    BCDArray1#6 = 0  
    BCDArray1#7 = 0
    BCDArray1#8 = 0    
    BCDArray1#9 = 0 

    Clear BCDArray2 
    '/ Loading a value into the BCD counters
    BCDArray2#0 = 0
    BCDArray2#1 = 0    
    BCDArray2#2 = 0
    BCDArray2#3 = 5
    BCDArray2#4 = 0
    BCDArray2#5 = 0
    BCDArray2#6 = 0
    BCDArray2#8 = 0
    BCDArray2#9 = 0

    Clear BCDArray3     
    '/ Loading a value into the BCD counters
    BCDArray3#0 = 1
    BCDArray3#1 = 4    
    BCDArray3#2 = 9
    BCDArray3#3 = 8
    BCDArray3#4 = 5
    BCDArray3#5 = 8
    BCDArray3#6 = 4
    BCDArray3#7 = 1
    BCDArray3#8 = 1
    BCDArray3#9 = 0
        
    HRSOut "NUMBER OF COUNTERS: ",Dec __VBCD_CounterLenght, CR, CR

    HRSOut "MULTIPLIER: " 
    HRSOut_BCDarray(1,0)
    HRSOut " X MULTIPLICAND: " 
    HRSOut_BCDarray(2,1)

    '/ MULTIPLIER   => Array nb 1
    '/ MULTIPLICAND => Array nb 2
    '/ PRODUCT      => Array nb 3        
    ErrorByte = MUL_BCD(1,2,3)

    If ErrorByte > 0 Then 
        HRSOut "OVERFLOW",CR,CR 
    EndIf 

    HRSOut "PRODUCT:    " 
    HRSOut_BCDarray(3,2)

    '/ Restore the MULTIPLIER
    HRSOut "CHECK THE MULTIPLIER: " 
    HRSOut_BCDarray(1,2)

    '/ Check the arrays
    HRSOut "Check Array1: " 
    HRSOut_BCDarray(1,1)
    HRSOut "Check Array2: " 
    HRSOut_BCDarray(2,1)
    HRSOut "Check Array3: " 
    HRSOut_BCDarray(3,2)            


    HRSOut "END TEST",CR
Stop

'/##############################################################################
    End
'/==============================================================================
 
