'****************************************************************
'*  Name    : Test_Tips_and_Tricks_MULV.BAS                     *
'*  Author  : [Alberto Freixanet]                               *
'*  Notice  : Copyright (c) 2018 [AFreixanet]                   *
'*          : All Rights Reserved                               *
'*  Date    : 29/09/2018                                        *
'*  Version : 1.0                                               *
'*  Notes   : Testing the Multiplication BCD counters command   *
'*          : (MULV_BCD) MULTIPLICAND in Variable               *
'****************************************************************
'/ Choose the include file depending of clock of ISIS CPU.
    Include "D:\MyIncFiles\proton18_16.inc"

    Declare Watchdog = OFF
'    Declare Float_Display_Type = Fast
'    Declare Float_Rounding = On             ' Round down to the nearest integer

'    Declare Reminders = Off
'    DECLARE LABEL_BANK_RESETS = ON
'    Declare Reminders = On
'    #define __INTERRUPTS_ENABLED 1

    $ifndef CR
    $define CR 13
    $endif
    $ifndef LF
    $define LF 10
    $endif

    Dim MyResultByte As Byte
    Dim MyResultWord As Word
    Dim MyResultDword As Dword
    Dim MyResultFloat As Float
    Dim MyMultiplierWord As Word
    Dim MyMultiplierDword As Dword    
    Dim MyMultiplierByte As Byte

    Dim ErrorByte As Byte
    Dim MyInputByte As Byte
    Dim MyInputWord As Word
    Dim MyInputDword As Dword            
    Dim MyInputFloat As Float

    Dim WordLoop As Word
    Dim ByteLoop As Byte

' Place the String at the End of the Dim list

'/==============================================================================
'/ UARTs
'    $define _HRSOutTwoStopBitsInc_
' Others libraries.
'    $define _ADCaverageA_
'    $define _ADCaverageB_    
'    $define _CountUntil_
'    $define _HEXtoASCII_
'    $define _IDLOCS_
'    $define _HRSLStrg_
'    $define _DegC_DegF_
'    $define _Map8_
'    $define _Map16_
'    $define _MapF_    
'    $define _GIE_Save_
'    $define _DEVID1_
'    $define _StringToFloat_
'    $define _DebounceByte_    
'    $define _MyRandom_
'    $define _GrayCode_

    $define NumberBCDCounters 15
    $define _BCDCounters_

    $define __MEASURE_CODE_
'/------------------------------------------------------------------------------
    '/ Create your own path in the Hard disk D:\MyIncFiles. 
    Include "D:\MyIncFiles\TIPS_AND_TRICKS_V16.Inc"
'/==============================================================================
    GoTo OverMacros                              ' Jump over the subroutines
'/==============================================================================


'/==============================================================================
OverMacros:
'/==============================================================================
                      
'/###############################################################################
'/ Main Demo Program
'/ Use the ISIS program to test the code.
'/ Click the ISIS button in the toolbar and choose the PIC18_ALCD_VHB.DSN board with normal LCD. 
'/###############################################################################
    Cls
MAIN:
    Disable_SWDTEN()   '/ Watchdog disabled por software.
'/------------------------------------------------------------------------------
    HRSOut "MULTIPLICATION  (MULV) WITH BCD COUNTERS BY A VARIABLE:",CR
    HRSOut "NUMBER OF COUNTERS: ",Dec __VBCD_CounterLenght,CR
    HRSOut "TEST 1: ",CR,CR    
    
    Clear BCDArray1
    '/ Loading a value into the BCD counters
    BCDArray1#0 = 4
    BCDArray1#1 = 5    
    BCDArray1#2 = 6
    BCDArray1#3 = 5
    BCDArray1#4 = 1
    BCDArray1#5 = 0    
    BCDArray1#6 = 0  
    BCDArray1#7 = 0
    BCDArray1#8 = 0    
    BCDArray1#9 = 0 
    BCDArray1#10 = 0    
    BCDArray1#11 = 0 
    
    Clear BCDArray2
    '/ Loading a value into the BCD counters
    BCDArray2#0 = 6
    BCDArray2#1 = 5    
    BCDArray2#2 = 8
    BCDArray2#3 = 4
    BCDArray2#4 = 8
    BCDArray2#5 = 3
    BCDArray2#6 = 1
    BCDArray2#8 = 0
    BCDArray2#9 = 0
    BCDArray2#10 = 0
    BCDArray2#11 = 0
        
    Clear BCDArray3
    '/ Loading a value into the BCD counters
    BCDArray3#0 = 1
    BCDArray3#1 = 4    
    BCDArray3#2 = 9
    BCDArray3#3 = 8
    BCDArray3#4 = 5
    BCDArray3#5 = 8
    BCDArray3#6 = 4
    BCDArray3#7 = 1
    BCDArray3#8 = 1
    BCDArray3#9 = 0
    BCDArray3#10 = 0
    BCDArray3#11 = 0
            
    MyMultiplierWord = 250
    HRSOut "MULTIPLIER: " 
    HRSOut_BCDarray(1,0)
    HRSOut " X MULTIPLICAND: ", Dec MyMultiplierWord,CR  
    
    '/ MULTIPLIER   => Array nb 1
    '/ MULTIPLICAND => MyMultiplierWord
    '/ PRODUCT      => Array nb 4
    ErrorByte = MULV_BCD(1,4,MyMultiplierWord)

    If ErrorByte > 0 Then 
        HRSOut "OVERFLOW",CR,CR 
    EndIf 

    HRSOut "PRODUCT:    " 
    HRSOut_BCDarray(4,3)
'/------------------------------------------------------------------------------
    HRSOut "NUMBER OF COUNTERS: ",Dec __VBCD_CounterLenght,CR
    HRSOut "TEST 2: ",CR,CR 

    Clear BCDArray1
    '/ Loading a value into the BCD counters
    BCDArray1#0 = 0
    BCDArray1#1 = 0    
    BCDArray1#2 = 0
    BCDArray1#3 = 6
    BCDArray1#4 = 5
    BCDArray1#5 = 0    
    BCDArray1#6 = 0  
    BCDArray1#7 = 0    
    BCDArray1#8 = 0
    BCDArray1#9 = 0    
    BCDArray1#10 = 0
    BCDArray1#11 = 0
    
    Clear BCDArray2
    '/ Loading a value into the BCD counters
    BCDArray2#0 = 0
    BCDArray2#1 = 0    
    BCDArray2#2 = 0
    BCDArray2#3 = 4
    BCDArray2#4 = 8
    BCDArray2#5 = 6
    BCDArray2#6 = 5
    BCDArray2#7 = 0
    BCDArray2#8 = 0
    BCDArray2#9 = 0
    BCDArray2#10 = 0
    BCDArray2#11 = 0
    
    Clear BCDArray3
    '/ Loading a value into the BCD counters
    BCDArray3#0 = 1
    BCDArray3#1 = 4    
    BCDArray3#2 = 9
    BCDArray3#3 = 8
    BCDArray3#4 = 5
    BCDArray3#5 = 8
    BCDArray3#6 = 7
    BCDArray3#7 = 1
    BCDArray3#8 = 0
    BCDArray3#9 = 0
    BCDArray3#10 = 0
    BCDArray3#11 = 0
        
    HRSOut "NUMBER OF COUNTERS: ",Dec __VBCD_CounterLenght,CR,CR
    
    MyMultiplierDword = 100000
    HRSOut "MULTIPLIER: " 
    HRSOut_BCDarray(2,0)
    HRSOut " X MULTIPLICAND: ", Dec MyMultiplierDword,CR  
    
    HRSOut "waiting...",CR
    '/ MULTIPLIER   => Array nb 2
    '/ MULTIPLICAND => MyMultiplierDword
    '/ PRODUCT      => Array nb 4
    ErrorByte = MULV_BCD(2,4,MyMultiplierDword)

    If ErrorByte > 0 Then 
        HRSOut "OVERFLOW",CR,CR 
    EndIf 

    HRSOut "PRODUCT:    " 
    HRSOut_BCDarray(4,3)

'/------------------------------------------------------------------------------
    HRSOut "NUMBER OF COUNTERS: ",Dec __VBCD_CounterLenght,CR
    HRSOut "TEST 3: ",CR,CR 

    Clear BCDArray1
    '/ Loading a value into the BCD counters
    BCDArray1#0 = 0
    BCDArray1#1 = 0    
    BCDArray1#2 = 0
    BCDArray1#3 = 6
    BCDArray1#4 = 5
    BCDArray1#5 = 0    
    BCDArray1#6 = 0  
    BCDArray1#7 = 0    
    BCDArray1#8 = 0
    BCDArray1#9 = 0    
    BCDArray1#10 = 0
    BCDArray1#11 = 0
    
    Clear BCDArray2
    '/ Loading a value into the BCD counters
    BCDArray2#0 = 0
    BCDArray2#1 = 0    
    BCDArray2#2 = 5
    BCDArray2#3 = 2
    BCDArray2#4 = 0
    BCDArray2#5 = 0
    BCDArray2#6 = 0
    BCDArray2#7 = 0
    BCDArray2#8 = 0
    BCDArray2#9 = 0
    BCDArray2#10 = 0
    BCDArray2#11 = 0
    
    MyMultiplierWord = 125
    HRSOut "MULTIPLIER: " 
    HRSOut_BCDarray(2,0)
    HRSOut " X MULTIPLICAND: ", Dec MyMultiplierWord,CR  
    
    HRSOut "waiting...",CR
    '/ MULTIPLIER   => Array nb 2
    '/ MULTIPLICAND => MyMultiplierDword
    '/ PRODUCT      => Array nb 4
    ErrorByte = MULV_BCD(2,4,MyMultiplierWord)

    If ErrorByte > 0 Then 
        HRSOut "OVERFLOW",CR,CR 
    EndIf 

    HRSOut "PRODUCT:    " 
    HRSOut_BCDarray(4,2)        


    HRSOut "MULV IS NOT RECOMMENDED FOR VERY LARGE NUMBERS!",CR
    HRSOut "END TEST",CR
Stop

'/##############################################################################
    End
'/==============================================================================
 
