'****************************************************************
'*  Name    : Test_Tips_and_Tricks_SUB.BAS                      *
'*  Author  : [Alberto Freixanet]                               *
'*  Notice  : Copyright (c) 2018 [AFreixanet]                   *
'*          : All Rights Reserved                               *
'*  Date    : 29/09/2018                                        *
'*  Version : 1.0                                               *
'*  Notes   : Testing subtraction command                       *
'*          : SUB_BCD(1,2,3) comamnd                            *
'****************************************************************
'/ Choose the include file depending of clock of ISIS CPU.
    Include "D:\MyIncFiles\proton18_16.inc"

    Declare Watchdog = OFF
'    Declare Float_Display_Type = Fast
'    Declare Float_Rounding = On             ' Round down to the nearest integer

'    Declare Reminders = Off
'    DECLARE LABEL_BANK_RESETS = ON
'    Declare Reminders = On
'    #define __INTERRUPTS_ENABLED 1

    Dim MyResultByte As Byte
    Dim MyResultWord As Word
    Dim MyResultDword As Dword
    Dim MyResultFloat As Float

    Dim MyInputByte As Byte
    Dim MyInputByte2 As Byte    
    Dim MyInputWord As Word
    Dim MyInputDword As Dword            
    Dim MyInputFloat As Float

    Dim WordLoop As Word
    Dim ByteLoop As Byte
    Dim ErrorByte As Byte

' Place the String at the End of the Dim list

'/==============================================================================
'/ UARTs
'    $define _HRSOutTwoStopBitsInc_
' Others libraries.
'    $define _ADCaverageA_
'    $define _ADCaverageB_    
'    $define _CountUntil_
'    $define _HEXtoASCII_
'    $define _IDLOCS_
'    $define _HRSLStrg_
'    $define _DegC_DegF_
'    $define _Map8_
'    $define _Map16_
'    $define _MapF_    
'    $define _GIE_Save_
'    $define _DEVID1_
'    $define _StringToFloat_
'    $define _DebounceByte_    
'    $define _MyRandom_
'    $define _GrayCode_

    $define NumberBCDCounters 12
    $define _BCDCounters_

    $define __MEASURE_CODE_
'/------------------------------------------------------------------------------
    '/ Create your own path in the Hard disk D:\MyIncFiles. 
    Include "D:\MyIncFiles\TIPS_AND_TRICKS_V16.Inc"
'/==============================================================================
    GoTo OverMacros                              ' Jump over the subroutines
'/==============================================================================


'/==============================================================================
OverMacros:
'/==============================================================================
                      
'/###############################################################################
'/ Main Demo Program
'/ Use the ISIS program to test the code.
'/ Click the ISIS button in the toolbar and choose the PIC18_ALCD_VHB.DSN board with normal LCD. 
'/###############################################################################
    Cls
MAIN:
'/------------------------------------------------------------------------------
    Clear BCDArray1
    '/ Loading a value into the BCD counters
    BCDArray1#0 = 4
    BCDArray1#1 = 5    
    BCDArray1#2 = 6
    BCDArray1#3 = 9
    BCDArray1#4 = 7
    BCDArray1#5 = 8    
    BCDArray1#6 = 7  
    BCDArray1#7 = 9
    BCDArray1#8 = 7
    BCDArray1#9 = 8    
    BCDArray1#10 = 0 
    BCDArray1#11 = 0 
    
    Clear BCDArray2    
    '/ Loading a value into the BCD counters
    BCDArray2#0 = 6
    BCDArray2#1 = 5    
    BCDArray2#2 = 8
    BCDArray2#3 = 4
    BCDArray2#4 = 8
    BCDArray2#5 = 5
    BCDArray2#6 = 6
    BCDArray2#7 = 5
    BCDArray2#8 = 9
    BCDArray2#9 = 6
    BCDArray2#10 = 0
    BCDArray2#11 = 0
        
    HRSOut "SUBTRACTION OF BCD COUNTERS :",CR,CR
    HRSOut "NUMBER OF COUNTERS: ",Dec __VBCD_CounterLenght,CR
    HRSOut "TEST 1:",CR,CR 

    HRSOut "Counter1 Init:   " 
    HRSOut_BCDarray(1,$F1)

    HRSOut "(-) Counter2:    " 
    HRSOut_BCDarray(2,$F1)

    ErrorByte = SUB_BCD(1,2,3)  '/ Fisrt Array - Second array = (Result) Third array

    If ErrorByte > 0 Then 
        HRSOut "OVERFLOW: MORE DIGITS ARE NEEDED!",CR,CR 
    EndIf 

    HRSOut "Counter3 Result: " 
    HRSOut_BCDarray(3,$F2)      '/ print the third array.

    '/ Check the arrays
    HRSOut "Check Array1: " 
    HRSOut_BCDarray(1,$F1)
    HRSOut "Check Array2: " 
    HRSOut_BCDarray(2,$F1)
    HRSOut "Check Array3: " 
    HRSOut_BCDarray(3,$F3)    
'/------------------------------------------------------------------------------
    HRSOut "NUMBER OF COUNTERS: ",Dec __VBCD_CounterLenght,CR
    HRSOut "TEST 2:",CR,CR 

    Clear BCDArray2
    '/ Loading a value into the BCD counters
    BCDArray2#0 = 6
    BCDArray2#1 = 5    
    BCDArray2#2 = 8
    BCDArray2#3 = 4
    BCDArray2#4 = 8
    BCDArray2#5 = 5
    BCDArray2#6 = 6
    BCDArray2#7 = 5
    BCDArray2#8 = 9
    BCDArray2#9 = 6
    BCDArray2#10 = 0
    BCDArray2#11 = 0

    Clear BCDArray3    
    '/ Loading a value into the BCD counters
    BCDArray3#0 = 1
    BCDArray3#1 = 4    
    BCDArray3#2 = 9
    BCDArray3#3 = 8
    BCDArray3#4 = 5
    BCDArray3#5 = 8
    BCDArray3#6 = 4
    BCDArray3#7 = 7
    BCDArray3#8 = 7
    BCDArray3#9 = 2
    BCDArray3#10 = 0
    BCDArray3#11 = 0
    
    HRSOut "Counter2 Init:   " 
    HRSOut_BCDarray(2,$F1)

    HRSOut "(-) Counter3:    "         
    HRSOut_BCDarray(3,$F1)

    ErrorByte = SUB_BCD(2,3,4)  '/ Second Array - Third array = (Result) Fourth array

    If ErrorByte > 0 Then 
        HRSOut "OVERFLOW: MORE DIGITS ARE NEEDED!",CR,CR 
    EndIf 

    HRSOut "Counter4 Result: " 
    HRSOut_BCDarray(4,$F2)      '/ print the Fourth array.

    '/ Check the arrays
    HRSOut "Check Array2: " 
    HRSOut_BCDarray(2,$F1)
    HRSOut "Check Array3: " 
    HRSOut_BCDarray(3,$F1)
    HRSOut "Check Array4: " 
    HRSOut_BCDarray(4,$F3)  
'/------------------------------------------------------------------------------
    HRSOut "NUMBER OF COUNTERS: ",Dec __VBCD_CounterLenght,CR
    HRSOut "TEST 3:",CR,CR

    Clear BCDArray1
    '/ Loading a value into the BCD counters
    BCDArray1#0 = 0
    BCDArray1#1 = 0    
    BCDArray1#2 = 1
    BCDArray1#3 = 0
    BCDArray1#4 = 0
    BCDArray1#5 = 0    
    BCDArray1#6 = 0  
    BCDArray1#7 = 0
    BCDArray1#8 = 0
    BCDArray1#9 = 0    
    BCDArray1#10 = 0 
    BCDArray1#11 = 0 
    
    Clear BCDArray2
    '/ Loading a value into the BCD counters
    BCDArray2#0 = 9
    BCDArray2#1 = 9    
    BCDArray2#2 = 0
    BCDArray2#3 = 0
    BCDArray2#4 = 0
    BCDArray2#5 = 0
    BCDArray2#6 = 0
    BCDArray2#7 = 0
    BCDArray2#8 = 0
    BCDArray2#9 = 0
    BCDArray2#10 = 0
    BCDArray2#11 = 0

    HRSOut "Counter1 Init:   " 
    HRSOut_BCDarray(1,$F1)

    HRSOut "(-) Counter2:    "         
    HRSOut_BCDarray(2,$F1)

    ErrorByte = SUB_BCD(1,2,3)  '/ Second Array - Third array = (Result) Fourth array

    If ErrorByte > 0 Then 
        HRSOut "OVERFLOW: MORE DIGITS ARE NEEDED!",CR,CR 
    EndIf 

    HRSOut "Counter3 Result: " 
    HRSOut_BCDarray(3,$F2)      '/ print the Third array.

    '/ Check the arrays
    HRSOut "Check Array1: " 
    HRSOut_BCDarray(1,$F1)
    HRSOut "Check Array2: " 
    HRSOut_BCDarray(2,$F1)
    HRSOut "Check Array3: " 
    HRSOut_BCDarray(3,$F2)               
'/==============================================================================
    HRSOut "NUMBER OF COUNTERS: ",Dec __VBCD_CounterLenght,CR
    HRSOut "TEST 4:",CR,CR

    Clear BCDArray1
    '/ Loading a value into the BCD counters
    BCDArray1#0 = 0
    BCDArray1#1 = 0    
    BCDArray1#2 = 0
    BCDArray1#3 = 0
    BCDArray1#4 = 1
    BCDArray1#5 = 0    
    BCDArray1#6 = 0  
    BCDArray1#7 = 0
    BCDArray1#8 = 0
    BCDArray1#9 = 0    
    BCDArray1#10 = 0 
    BCDArray1#11 = 0 
    
    Clear BCDArray2
    '/ Loading a value into the BCD counters
    BCDArray2#0 = 1
    BCDArray2#1 = 0    
    BCDArray2#2 = 0
    BCDArray2#3 = 0
    BCDArray2#4 = 1
    BCDArray2#5 = 0
    BCDArray2#6 = 0
    BCDArray2#7 = 0
    BCDArray2#8 = 0
    BCDArray2#9 = 0
    BCDArray2#10 = 0
    BCDArray2#11 = 0

    HRSOut "Counter1 Init:   " 
    HRSOut_BCDarray(1,$F1)

    HRSOut "(-) Counter2:    "         
    HRSOut_BCDarray(2,$F1)

    ErrorByte = SUB_BCD(1,2,3)  '/ Second Array - Third array = (Result) Fourth array

    If ErrorByte > 0 Then 
        HRSOut "OVERFLOW: MORE DIGITS ARE NEEDED!",CR,CR 
    EndIf 

    HRSOut "Counter3 Result: " 
    HRSOut_BCDarray(3,$F2)      '/ print the Third array.

    '/ Check the arrays
    HRSOut "Check Array1: " 
    HRSOut_BCDarray(1,$F1)
    HRSOut "Check Array2: " 
    HRSOut_BCDarray(2,$F1)
    HRSOut "Check Array3: " 
    HRSOut_BCDarray(3,$F2)  

'/------------------------------------------------------------------------------
    HRSOut "END TEST",CR 

'/------------------------------------------------------------------------------
Stop
'/##############################################################################
    End
'/==============================================================================
 
