'****************************************************************
'*  Name    : CW_BeaconA_25K22.BAS                              *
'*  Author  : [Alberto Freixanet]                               *
'*  Notice  : Copyright (c) 2018 [AFreixanet]                   *
'*          : All Rights Reserved                               *
'*  Date    : 14/10/2018                                        *
'*  Version : 1.0                                               *
'*  Notes   : CW Beacon only                                    *
'*          : Code based on an idea of Code                     *
'*          : from  Sierra Radio Systems & HomeHamStack        *
'*The original code has been 100% modified for better efficiency*
'****************************************************************

    $define _CheckRCONBits_
    $define  __WatchDog_ON      '/Special Declare Watchdog
    $define PLL_ConfigFuses OFF
    Include "D:\MyIncFiles\Amicus18_25K20.inc"
'    Include "D:\MyIncFiles\Proton18_16.inc"
'    Declare Float_Display_Type = Fast
    Declare Watchdog = OFF

    Dim BeaconExit As Byte

    $define CWButtonStop PORTA.3    ' "CWButtonStop" to port RA3.    

    $define CWRelay LATC.0    ' "CWRelay" to port RC0.
    $define CWLed   LATC.1    ' "CWLed" to port RC1.
    $define CWPTT   LATC.3    ' "CWPTT" to port RC3.
    $define _CWBeacon_
    $define __MEASURE_CODE_

    Include "D:\MyIncFiles\TIPS_AND_TRICKS_V16.Inc"
'/==============================================================================
    MyDelayMS(500)          '/ Pause for 500ms after hardware reset with special Watchdog

    HRSOut_RCON()           '/ Check the hardware reset origin.

CWAGAIN:

'/ Send 1 message forever.
    HRSOut "BEACON DEMO: SEND A MESSAGE FOREVER:",CR,CR

    CWBeacon_MESG(1,255) '/ Declare the String(1) to send forever.

    HRSOut "Beacon is sending:[",CW_String,"] forever:",CR,CR 

    '/ PTT ON.
    Do
        CWBeacon_Send(16)    '/ WPM = 16
    Loop

    HRSOut "END TEST",CR 
    MyStop()
'/------------------------------------------------------------------------------
CWMessagesTable: CData Word CWTXT01,CWTXT02,CWTXT03,CWTXT04,CWTXT05,CWTXT06,CWTXT07,CWTXT08

CWTXT01: CData "CQ CQ CQ DE EA3AGV EA3AGV EA3AGV",0
CWTXT02: CData "CQ CQ CQ DE EA3AGV EA3AGV",0
CWTXT03: CData "CQ CQ DE EA3AGV",0
CWTXT04: CData "CW BEACON POWERED BY PROTON DEVELOPMENT SUITE V3.6.2.3",0
CWTXT05: CData "MY QTH QTH IS BARCELONA SPAIN",0
CWTXT06: CData "UR RST RST IS 599 599 MY NAME IS AL AL",0
CWTXT07: CData "TNX FOR QSO AND 73 DE EA3AGV",0
CWTXT08: CData "pds cw beacon written by ea3agv",0 '/ To test low to high case code.
'/------------------------------------------------------------------------------
    End

 
