'****************************************************************
'*  Name    : CW_memory_25K20.BAS                               *
'*  Author  : [Alberto Freixanet]                               *
'*  Notice  : Copyright (c) 2018 [AFreixanet]                   *
'*          : All Rights Reserved                               *
'*  Date    : 18/10/2018                                        *
'*  Version : 1.0                                               *
'*  Notes   : Demo code Memory KEYER                            *
'*          : Code based on an idea of Code                     *
'*          : from  Sierra Radio Systems & HomeHamStack        *
'*The original code has been 100% modified for better efficiency*
'****************************************************************

    $define _CheckRCONBits_
    $define  __WatchDog_ON      '/Special Declare Watchdog
    $define PLL_ConfigFuses OFF
    Include "D:\MyIncFiles\Amicus18_25K20.inc"
'    Include "D:\MyIncFiles\Proton18_16.inc"
'    Declare Float_Display_Type = Fast
    Declare Watchdog = OFF

    Dim MessageCounter As Byte
    Dim MemoryKeyerExit As Byte
    
    '/ Define every message to Buttons.
    $define CWButton1Msg 2
    $define CWButton2Msg 4
    $define CWButton3Msg 5        
    $define CWButton4Msg 6 
    $define CWButton5Msg 7 
    
    '/ Define the Hardware Pins for Buttons.
    $define CWButton1 PORTC.4       ' "CWButton1" to port RC4. 
    $define CWButton2 PORTC.5       ' "CWButton2" to port RC5.
    $define CWButton3 PORTA.0       ' "CWButton3" to port RA0.
    $define CWButton4 PORTA.1       ' "CWButton4" to port RA1.
    $define CWButton5 PORTA.2       ' "CWButton4" to port RA2.
    $define CWButtonStop PORTA.3    ' "CWButtonStop" to port RA3.

    '/ Define the Hardware Pins for Outputs.
    $define CWRelay LATC.0    ' "CWRelay" to port RC0.
    $define CWLed   LATC.1    ' "CWLed" to port RC1.
    $define CWPTT   LATC.3    ' "CWPTT" to port RC3.

    $define _CWBeacon_
    $define __MEASURE_CODE_
    Include "D:\MyIncFiles\TIPS_AND_TRICKS_V16.Inc"

'/==============================================================================
MAIN:
    MyDelayMS(500)          '/ Pause for 500ms after hardware reset with special Watchdog

    HRSOut_RCON()           '/ Check the hardware reset origin.
'/------------------------------------------------------------------------------

    HRSOut "DEMO MEMORY KEYER!",CR
    HRSOut "5 BUTTONS ALLOW TO SEND 5 DIFFERENT MESSAGES:",CR
    HRSOut "AND 1 BUTTON TO STOP TRANSMISION:",CR,CR    
    
    '/ Infinite loop for Memory Keyer.
    Do
        HRSOut "PRESS A BUTTON!",CR,CR
        CWWait_Buttons()       '/ Press the Button (1 to 5) to start a message.

        HRSOut "Sending Message number: ", Dec CWMsgNumber + 1," [",CW_String,"]",CR,CR 

        CWBeacon_Send(18)  '/ WPM = 18
    Loop

'/------------------------------------------------------------------------------
    HRSOut "END TEST",CR    
    MyStop()
'/------------------------------------------------------------------------------
CWMessagesTable: CData Word CWTXT01,CWTXT02,CWTXT03,CWTXT04,CWTXT05,CWTXT06,CWTXT07,CWTXT08,CWTXT09
'/ EOT1 => Shutt down the transmitter at the final of text for all messages.
'/                                              
CWTXT01: CData "CQ CQ CQ DE EA3AGV EA3AGV EA3AGV # K",EOT1,0
CWTXT02: CData "CQ CQ CQ DE EA3AGV EA3AGV # K",EOT1,0
CWTXT03: CData "CQ CQ DE EA3AGV # K",EOT1,0
CWTXT04: CData "TNX FER CALL UR RST RST IS 599 5NN FB MY NAME IS AL AL # &",EOT1,0
CWTXT05: CData "MY RIG IC703 PWR 5W ANT LW # &",EOT1,0
CWTXT06: CData "MY QTH QTH IS BARCELONA SPAIN # &",EOT1,0
CWTXT07: CData "TNX FER QSO DR OM AND 73 73 DE EA3AGV GB ^",EOT1,0
CWTXT08: CData "pds cw beacon written by ea3agv # ^",EOT1,0
CWTXT09: CData "CW BEACON POWERED BY PROTON DEVELOPMENT SUITE V3.6.2.3 # ^",EOT1,0
'/------------------------------------------------------------------------------
    End

 
