'****************************************************************
'*  Name    : Test_Tips_and_Tricks.BAS                          *
'*  Author  : [Alberto Freixanet]                               *
'*  Notice  : Copyright (c) 2018 [AFreixanet]                   *
'*          : All Rights Reserved                               *
'*  Date    : 29/09/2018                                        *
'*  Version : 1.0                                               *
'*  Notes   : Testing Write/Read IDLOCS and LoadString commands *
'*          :                                                   *
'****************************************************************
'/ Choose the include file depending of clock of ISIS CPU.
    Include "D:\MyIncFiles\proton18_16.inc"

    Declare Watchdog = OFF
'    Declare Float_Display_Type = Fast
'    Declare Float_Rounding = On             ' Round down to the nearest integer

'    Declare Reminders = Off
'    DECLARE LABEL_BANK_RESETS = ON
'    Declare Reminders = On
    #define __INTERRUPTS_ENABLED 1

    Dim MyResultByte As Byte
    Dim MyResultWord As Word
    Dim MyResultSWord As SWord    
    Dim MyResultDword As Dword
    Dim MyResultFloat As Float

    Dim MyResultRDword As Word

    Dim MyInputByte As Byte
    Dim MyInputWord As Word
    Dim MyInputDword As Dword            
    Dim MyInputFloat As Float

    Dim WordLoop As Word
    Dim ByteLoop As Byte
    
' Place the String at the End of the Dim list


'/==============================================================================
'/ UARTs
'    $define _HRSOutTwoStopBitsInc_
' Others libraries.
'    $define _ADCaverageA_
'    $define _ADCaverageB_    
'    $define _CountUntil_
'    $define _HEXtoASCII_
    $define _IDLOCS_
'    $define _HRSLStrg_
'    $define _DegC_DegF_
'    $define _Map8_
'    $define _Map16_
'    $define _MapF_    
    $define _GIE_Save_
'    $define _DEVID1_
'    $define _BCDCounters_
'    $define _StringToFloat_
'    $define _DebounceByte_    
'    $define _MyRandom_
'    $define _GrayCode_

    $define __MEASURE_CODE_
'/------------------------------------------------------------------------------
    '/ Create your own path in the Hard disk D:\MyIncFiles.
    Include "D:\MyIncFiles\TIPS_AND_TRICKS_V16.Inc"
'/==============================================================================
    GoTo OverMacros                              ' Jump over the subroutines
'/==============================================================================


'/==============================================================================
OverMacros:
'/==============================================================================
                            
'/###############################################################################
' Main Demo Program
'/ Use the ISIS program to test the code.
'/ Click the ISIS button in the toolbar and choose the PIC18_ALCD_VHB.DSN board with normal LCD. 
'/###############################################################################
    Cls
MAIN:

    HRSOut "TESTING READ & WRITE IDLOCS",CR,CR 

    HRSOut "Writing IDLOCS  = PDSV3617",CR
    IDLOCSStrg = "PDSV3617"
    MyResultByte = WriteIDLOCS()    '/ Return a byte error.

    HRSOut CR

    If MyResultByte = 0 Then        '/ No error?    
        HRSOut "IDLOCS Correct ? = ", IDLOCSStrg,CR
     Else                            '/ There is a writing error.
        HRSOut "ERROR to Write/Read the IDLOCS",CR    
    EndIf

    HRSOut CR

    ReadIDLOCS()
    HRSOut "Read IDLOCS again = ", IDLOCSStrg,CR
    
    HRSOut "Erasing IDLOCS with $FF character:",CR
    '/ This is a String: Write character $FF into the String.
    LoadString(IDLOCSStrg,8,$FF) 

    MyResultByte = WriteIDLOCS()    '/ Return a byte error.
    If MyResultByte = 0 Then        '/ No error?    
        HRSOut "No error to Write IDLOCS",CR
    EndIf

    HRSOut CR
    HRSOut "Read IDLOCS again = "
    ReadIDLOCS()
    
    '/ Check the String
    For ByteLoop = 0 To 7
        MyResultByte = IDLOCSStrg[ByteLoop]         
        If ByteLoop < 7 Then
            HRSOut IHex2 MyResultByte,","
        Else
            HRSOut IHex2 MyResultByte        
        EndIf
    Next
    HRSOut CR

    HRSOut "END TEST",CR
    Stop


'/##############################################################################
    End
'/==============================================================================
 
