$ifndef _PROTON18_INC
$define _PROTON18_INC
' Header file for the Proton Development Board
' Using a 18F4550 Device with a 48MHz Oscillator
'
    Device = 18F4550
    Declare Xtal = 48

    Declare LCD_DTPin = PORTD.4
    Declare LCD_RSPin = PORTE.0
    Declare LCD_ENPin = PORTE.1
    Declare LCD_Interface = 4
    Declare LCD_Lines = 2
    Declare LCD_Type = 0
    Declare LCD_CommandUs = 2000
    Declare LCD_DataUs = 50

    Declare SCL_Pin = PORTB.1
    Declare SDA_Pin = PORTB.0

    Declare Serial_Baud = 9600
    Declare RsOut_Pin = PORTC.6
    Declare RsOut_Mode = 0
    Declare RsOut_Pace = 1000
    Declare RsIn_Pin = PORTC.7
    Declare RsIn_Mode = 0

    Declare Hserial_Baud = 9600                     ' Set baud rate to 9600
    Declare Hserial_RCSTA = %10010000               ' Enable serial port and continuous receive
    Declare Hserial_TXSTA = %00100000               ' Enable transmit and asynchronous mode
    Declare Hserial_Clear = On                      ' Enable Error clearing on received characters

    Declare Keypad_Port = PORTB

    Declare CCP1_Pin = PORTC.2
    Declare CCP2_Pin = PORTC.1

    Symbol T300 = 3313
    Symbol N300 = 3313 + $4000
    Symbol T600 = 1646
    Symbol N600 = 1646 + $4000
    Symbol T1200 = 813
    Symbol N1200 = 813 + $4000
    Symbol T2400 = 396
    Symbol N2400 = 396 + $4000
    Symbol T4800 = 188
    Symbol N4800 = 188 + $4000
    Symbol T9600 = 84
    Symbol N9600 = 84 + $4000

    Symbol OT2400 = 396 + $8000                     ' Open True
    Symbol OT1200 = 813 + $8000                     ' Open True
    Symbol OT9600 = 84 + $8000                      ' Open True
    Symbol OT300 = 3313 + $8000                     ' Open True

    Symbol ON2400 = 396 + $4000 + $8000             ' Open Inverted
    Symbol ON1200 = 813 + $4000 + $8000             ' Open Inverted
    Symbol ON9600 = 84 + $4000 + $8000              ' Open Inverted
    Symbol ON300 = 3313 + $4000 + $8000             ' Open Inverted

'ASCII characters  
    Symbol ESC = $1B    ' Escape
    Symbol ACK = 6
    Symbol STX = 2
    Symbol ETX = 3
    Symbol SPACE = $20
    Symbol Home = 1
    Symbol Bell = 7
    Symbol BkSp = 8
    Symbol Tab = 9

    $ifndef CR
    $define CR 13
    $endif
    $ifndef LF
    $define LF 10
    $endif

    $ifndef False
    $define False 0
    $endif
    $ifndef True
    $define True 1
    $endif

'/==============================================================================
$ifndef __ExtraPICParameters
$define __ExtraPICParameters
$if _device = _18F4550
    $define __DEVICE_ID 144
    $define __DEVICE_NAME "PIC18F4550"

    $ifndef _erase
    $define _erase 64
    $endif
$endif

$endif
'/==============================================================================
$ifdef _CheckRCONBits_
    '/ Control of the RCON register.
    Dim RCONBits As Byte System
    $define __RCONBitsHeader
    RCONBits = RCON
$endif
'/==============================================================================
    $define __SWDTEN_CFG   
    #ifdef Watchdog_req
    Clrwdt
    WDTCONBits_SWDTEN = 1
    #else
    WDTCONBits_SWDTEN = 0    
    #endif
'/==============================================================================   


    Declare All_Digital = True       ' Set PORTA and PORTE to all digital
$endif
'/------------------------------------------------------------------------------

