'****************************************************************
'*  Name    : Test_Tips_and_Tricks.BAS                          *
'*  Author  : [Alberto Freixanet]                               *
'*  Notice  : Copyright (c) 2018 [AFreixanet]                   *
'*          : All Rights Reserved                               *
'*  Date    : 29/09/2018                                        *
'*  Version : 1.0                                               *
'*  Notes   : Testing the InkeyX command                        *
'*          :                                                   *
'****************************************************************
'/ Choose the include file depending of clock of ISIS CPU.
    Include "D:\MyIncFiles\proton18_16.inc"

'    Declare Float_Display_Type = Fast
'    Declare Float_Rounding = On             ' Round down to the nearest integer
    Declare Watchdog = Off
'    Declare Reminders = Off
'    DECLARE LABEL_BANK_RESETS = ON
'    Declare Reminders = On
'    #define __INTERRUPTS_ENABLED 1
'    #define WatchDog_Req 1
    
    Dim MyResultByte As Byte
    Dim MyResultWord As Word
    Dim MyResultSWord As SWord    
    Dim MyResultDword As Dword
    Dim MyResultFloat As Float

    Dim MyResultRDword As Word

    Dim MyInputByte As Byte
    Dim MyInputWord As Word
    Dim MyInputDword As Dword            
    Dim MyInputFloat As Float

    Dim WordLoop As Word
    Dim ByteLoop As Byte
    Dim KEYvalue As Byte
    Dim F_KeyPressed As Bit
    Dim Toogle1 As Bit
    Dim Toogle2 As Bit
    Dim Toogle3 As Bit        
' Place the String at the End of the Dim list

'/==============================================================================
'/ UARTs
'    $define _HRSOutTwoStopBitsInc_
' Others libraries.
'    $define _ADCaverageA_
'    $define _ADCaverageB_    
'    $define _CountUntil_
'    $define _HEXtoASCII_
'    $define _IDLOCS_
'    $define _DegC_DegF_
'    $define _Map8_
'    $define _Map16_
'    $define _MapF_    
'    $define _GIE_Save_
'    $define _DEVID1_
'    $define _BCDCounters_
'    $define _StringToFloat_
'    $define _DebounceByte_    
'    $define _MyRandom_
'    $define _GrayCode_
'    $define _HRSE2PStrg_
    $define _CLL_
'    $define _PrintStrg_
'    $define _HRSLStrg_
'    $define _English_

    $define _4x4KEYPAD_
'    $define _4x3KEYPAD_    
'    $define _4x2KEYPAD_  

    $define __MEASURE_CODE_
'/------------------------------------------------------------------------------
    '/ Create your own path in the Hard disk D:\MyIncFiles.
    Include "D:\MyIncFiles\TIPS_AND_TRICKS_V16.Inc"
'/==============================================================================
    GoTo OverMacros                              ' Jump over the subroutines
'/==============================================================================
     

'/==============================================================================
OverMacros:
'/==============================================================================
                            
'/###############################################################################
' Main Demo Program
'/ Use the ISIS program to test the code.
'/ Click the ISIS button in the toolbar and choose the PIC18_ALCD_VHB.DSN board with normal LCD. 
'/###############################################################################
STARTSIZE(KEYPAD_CODE)
'    Disable_Watchdog()
'    Enable_Watchdog()
    If WDTCONBits_SWDTEN = 1 Then
        HRSOut "THE SWDTEN BIT IS SET (WATCHDOG):",CR    
    EndIf
    $ifndef _4x4KEYPAD_
    Low LATB.0
    $endif
    Cls
MAIN:
    HRSOut "TEST THE INKEYX COMMAND:",CR

    F_KeyPressed = 0
    Print At 1,1,"  TEST INKEYX   "
    DelayMS 250
    Print At 2,1," WAITING A KEY  "
    Repeat
        Do
            KEYvalue = InkeyX(150)      '/ EMI filter Delay to read the PORTx = 100US
            If KEYvalue > 0 Then        '/ NO Key pressed then MyResultByte = 0
                $ifdef _4x4KEYPAD_
                MyResultByte = LookUpL KEYvalue,["N","7","8","9","/","4","5","6","X","1","2","3","-","C","0","=","+"]
                $endif
                $ifdef _4x3KEYPAD_
                MyResultByte = LookUpL KEYvalue,["N","1","2","3","4","5","6","7","8","9","X","0","#"]
                $endif
                $ifdef _4x2KEYPAD_
                MyResultByte = LookUpL KEYvalue,["N","1","2","4","5","7","8","X","0"]
                $endif
                Break                   '/ Key pressed                   
            EndIf
            DelayMS 40
            '/ Using a led while the scanning of the keypad is running.
            $ifndef _4x4KEYPAD_
            GoSub ToggleLED_Sub
            $endif
        Loop       

        Print At 1,1,"  KEY ",Dec KEYvalue," PRESSED " 
        CLL(2)
        Print At 2,1,"  KEYPAD ",MyResultByte 

    $ifdef _4x4KEYPAD_
    Until MyResultByte = "C"
    $endif
    $ifdef _4x3KEYPAD_
    Until MyResultByte = "#"
    $endif   
    $ifdef _4x2KEYPAD_
    Until MyResultByte = "X"
    $endif  

    CLL()
    $ifdef _4x4KEYPAD_
    Print At 1,1," KEY C PRESSED "        
    $endif
    $ifdef _4x3KEYPAD_
    Print At 1,1," KEY # PRESSED "        
    $endif
    $ifdef _4x2KEYPAD_
    Print At 1,1," KEY X PRESSED "        
    $endif
    Print At 2,1,"EXIT TEST INKEYX" 
    DelayMS 1000

    CLL()
    Print At 1,1,"   TRY AGAIN    "
    HRSOut "TRY AGAIN",CR
    DelayMS 1000
    CLL()

    GoTo MAIN

$ifndef _4x4KEYPAD_
ToggleLED_Sub:
    Toggle Toogle1
    If Toogle1 = 1 Then
        Toggle Toogle2
        If Toogle2 = 1 Then
            Toggle Toogle3
            If Toogle3 = 1 Then
                Toggle LATB.0
            EndIf
        EndIf
    EndIf
    Return
$endif
ENDSIZE(KEYPAD_CODE)
'/##############################################################################
    End
'/==============================================================================
  
