'*******************************************************************************
'*  Name    : Test_Tips_and_Tricks_Sign.BAS                                    *
'*  Author  : [Alberto Freixanet]                                              *
'*  Notice  : Copyright (c) 2018 [AFreixanet]                                  *
'*          : All Rights Reserved                                              *
'*  Date    : 07/10/2018                                                       *
'*  Version : 1.0                                                              *
'*  Notes   : Check the ConvToFloat command                                    *
'*          : Create your path in the Hard disk D:\MyIncFiles                  *
'*          : & and copy all include files from INC folder                     *
'*                                                                             *
'* Important Note: Decimals can not be added to a negative number. This causes *
'*                 a deviation of the float value. Therefore, this macro should*
'*                 be used to add decimals to a float number.                  *
'*******************************************************************************

'/ Choose the include file depending of clock of ISIS CPU.
    '/ Enable the commands to check the states of the PIC at reset.

    $define _CheckRCONBits_ '/ Control the reset of PIC.
'/------------------------------------------------------------------------------
    Include "D:\MyIncFiles\Proton18_16.inc"

    Declare Float_Display_Type = Fast
'    Declare Float_Rounding = On             ' Round down to the nearest integer
    Declare Watchdog = OFF

'    Declare Reminders = Off
'    DECLARE LABEL_BANK_RESETS = ON
'    Declare Reminders = On

    Dim MyResultByte As Byte
    Dim MyResultWord As Word
    Dim MyResultDword As Dword
    Dim MyResultSByte As SByte
    Dim MyResultSWord As SWord   

    Dim MyRemainderSWord As SWord
    Dim MyRemainderSByte As SByte
    Dim MyRemainderWord As Word
    Dim MyRemainderByte As Byte

    Dim MyDecimalByte As Byte
    Dim MyDecimalSByte As SByte
    Dim MyDecimalWord As Word
    Dim MyDecimalSWord As SWord
    Dim MyDecimalDWord As Dword


    Dim MyInputByte As Byte
    Dim MyInputWord As Word
    Dim MyInputDword As Dword 
    Dim MyInputSByte As SByte
    Dim MyInputSWord As SWord 
    Dim MyInputSDword As SDword
    Dim MyInputFloat As Float

    Dim MyDivisorByte As Byte
    Dim MyDivisorWord As Word
    Dim MyDivisorSByte As SByte 
    Dim MyDivisorSWord As SWord

    Dim MyResultFloat As Float
    Dim MyTempFloat As Float    

    Dim TempByte As Byte
    Dim ByteLoop As Byte
    
' Place the String at the End of the Dim list

'/==============================================================================

    $define _ConvToFloat_
    $define __MEASURE_CODE_
'/------------------------------------------------------------------------------
    '/ Create your own path in the Hard disk D:\MyIncFiles.
    Include "D:\MyIncFiles\TIPS_AND_TRICKS_V16.Inc"
'/==============================================================================
    GoTo OverMacros                              ' Jump over the subroutines
'/==============================================================================

'/==============================================================================
OverMacros:
'/==============================================================================
                            
'/###############################################################################
'/ Main Demo Program
'/ Use the ISIS program to test the code.
'/ Click the ISIS button in the toolbar and choose the PIC18_ALCD_VHB.DSN board with normal LCD. 
'/###############################################################################
    '/ New command to know the PIC Reset states.
    HRSOut_RCON()   '/ Checking the different states of the PIC At Reset  
    HRSOut CR
    Cls
MAIN:

'    STARTSIZE(TEST_FLOAT_CODE)
'/------------------------------------------------------------------------------
    HRSOut "TEST01:",CR
    HRSOut "INPUT POSITIVE DWord:",CR

    HRSOut "Input DWord:",CR
    MyInputDword = 18420    '/ Whole part.
    MyDecimalWord = 568     '/ Decimal part    
    HRSOut "Input Variables:  ", Dec MyInputDword,".", Dec3 MyDecimalWord,CR

    MyResultFloat = MyInputDword
    MyResultFloat = MyResultFloat + (MyDecimalWord / 1000)

    HRSOut "Result Float 3 dec: ", Dec3 MyResultFloat,CR
    HRSOut CR
'/------------------------------------------------------------------------------
    HRSOut "TEST02:",CR
    HRSOut "INPUT POSITIVE Word:",CR

    HRSOut "Input Word:",CR
    MyInputWord = 8420      '/ Whole part.
    MyDecimalWord = 987     '/ Decimal part    
    HRSOut "Input Variables:  ", Dec MyInputWord,".", Dec3 MyDecimalWord,CR

    MyResultFloat = MyInputWord
    MyResultFloat = MyResultFloat + (MyDecimalWord / 1000)

    HRSOut "Result Float 3 dec: ", Dec3 MyResultFloat,CR
    HRSOut CR
'/------------------------------------------------------------------------------
    HRSOut "TEST03:",CR
    HRSOut "INPUT POSITIVE Byte:",CR

    HRSOut "Input Byte:",CR
    MyInputByte = 96        '/ Whole part.
    MyDecimalByte = 8       '/ Decimal part    
    HRSOut "Input Variables:  ", Dec MyInputByte,".", Dec3 MyDecimalByte,CR

    MyResultFloat = MyInputByte
    MyResultFloat = MyResultFloat + (MyDecimalByte / 1000)

    HRSOut "Result Float 3 dec: ", Dec3 MyResultFloat,CR
    HRSOut CR
'/------------------------------------------------------------------------------
    HRSOut "TEST04:",CR
    HRSOut "INPUT NEGATIVE SDword:",CR

    HRSOut "Input SDWord:",CR
    MyInputSDword = -18420  '/ Whole part.
    MyDecimalSWord = -453    '/ Decimal part    
    MyDecimalWord = Abs MyDecimalSWord
    HRSOut "Input Variables:  ", SDec MyInputSDword,".", Dec3 MyDecimalWord,CR

    MyResultFloat = MyInputSDword
    MyResultFloat = MyResultFloat + (MyDecimalSWord / 1000)

    HRSOut "Result Float 3 dec: ", Dec3 MyResultFloat,CR
    HRSOut CR
'/------------------------------------------------------------------------------
    HRSOut "TEST05:",CR
    HRSOut "INPUT POSITIVE SDWord:",CR

    HRSOut "Input SDword:",CR
    MyInputSDword = 184200    '/ Whole part.
    MyDecimalWord = 453       '/ Decimal part    
    HRSOut "Input Variables:  ", SDec MyInputSDword,".", Dec3 MyDecimalWord,CR

    MyResultFloat = MyInputSDword
    MyResultFloat = MyResultFloat + (MyDecimalWord / 1000)

    HRSOut "Result Float 3 dec: ", Dec3 MyResultFloat,CR
    HRSOut CR
'/------------------------------------------------------------------------------
    HRSOut "TEST06:",CR
    HRSOut "INPUT NEGATIVE SWord:",CR

    HRSOut "Input SWord:",CR
    MyInputSWord = -8420    '/ Whole part.
    MyDecimalSWord = -987     '/ Decimal part    
    HRSOut "Input Variables:  ", SDec MyInputSWord,".", Dec3 Abs MyDecimalSWord,CR

    MyResultFloat = MyInputSWord
    MyResultFloat = MyResultFloat + (MyDecimalSWord / 1000)

    HRSOut "Result Float 3 dec: ", Dec3 MyResultFloat,CR
    HRSOut CR
'/------------------------------------------------------------------------------
    HRSOut "TEST07:",CR
    HRSOut "INPUT NEGATIVE SByte:",CR

    HRSOut "Input SByte:",CR
    MyInputSByte = -125     '/ Whole part.
    MyDecimalSByte = -11   '/ Decimal part    
    TempByte = Abs MyDecimalSByte
    HRSOut "Input Variables:  ", SDec MyInputSByte,".", Dec3 TempByte,CR

    MyResultFloat = MyInputSByte
    '/ Error with SByte division in PDS version 3.6.2.3
    MyResultFloat = MyResultFloat + (MyDecimalSByte / 1000)

    HRSOut "Result Float 3 dec: ", Dec3 MyResultFloat,CR
    HRSOut CR
'/------------------------------------------------------------------------------
    HRSOut "TEST08:",CR
    HRSOut "INPUT POSITIVE SByte:",CR

    HRSOut "Input SByte:",CR
    MyInputSByte = 109     '/ Whole part.
    MyDecimalSByte = 8     '/ Decimal part    
    HRSOut "Input Variables:  ", SDec MyInputSByte,".", SDec3 MyDecimalSByte,CR

    MyResultFloat = MyInputSByte
    MyResultFloat = MyResultFloat + (MyDecimalSByte / 1000)

    HRSOut "Result Float 3 dec: ", Dec3 MyResultFloat,CR
    '/--------------------------------------------------------------------------     
    HRSOut CR
    HRSOut "END TEST: ",CR
'/------------------------------------------------------------------------------
'    ENDSIZE(TEST_FLOAT_CODE)

    Stop
'/##############################################################################
    End
'/==============================================================================
 
