'****************************************************************
'*  Name    : Test_Tips_and_Tricks_DIVX.BAS                     *
'*  Author  : [Alberto Freixanet]                               *
'*  Notice  : Copyright (c) 2018 [AFreixanet]                   *
'*          : All Rights Reserved                               *
'*  Date    : 29/09/2018                                        *
'*  Version : 1.0                                               *
'*  Notes   : Testing the LenArray command                      *
'*          : LENArray/LENBCDArray commands                     *
'****************************************************************
'/ Choose the include file depending of clock of ISIS CPU.
    Include "D:\MyIncFiles\proton18_16.inc"

    Declare Watchdog = OFF
'    Declare Float_Display_Type = Fast
'    Declare Float_Rounding = On             ' Round down to the nearest integer

'    Declare Reminders = Off
'    DECLARE LABEL_BANK_RESETS = ON
'    Declare Reminders = On
'    #define __INTERRUPTS_ENABLED 1

    Dim MyResultByte As Byte
    Dim MyResultWord As Word
    Dim MyResultSWord As SWord    
    Dim MyResultDword As Dword
    Dim MyResultFloat As Float
    Dim MyMultiplierWord As Word
    Dim MyResultRDword As Word

    Dim MyInputByte As Byte
    Dim MyInputWord As Word
    Dim MyInputDword As Dword            
    Dim MyInputFloat As Float
    Dim LoopByte As Byte
    Dim ErrorByte As Byte

' Place the String at the End of the Dim list


'/==============================================================================
'/ UARTs
'    $define _HRSOutTwoStopBitsInc_
' Others libraries.
'    $define _ADCaverageA_
'    $define _ADCaverageB_    
'    $define _CountUntil_
'    $define _HEXtoASCII_
'    $define _IDLOCS_
'    $define _HRSLStrg_
'    $define _DegC_DegF_
'    $define _Map8_
'    $define _Map16_
'    $define _MapF_    
'    $define _GIE_Save_
'    $define _DEVID1_
'    $define _StringToFloat_
'    $define _DebounceByte_    
'    $define _MyRandom_
'    $define _GrayCode_

    $define _LENArray_
    $define NumberBCDCounters 12
    $define _BCDCounters_

    $define __MEASURE_CODE_
'/------------------------------------------------------------------------------
    '/ Create your own path in the Hard disk D:\MyIncFiles.
    Include "D:\MyIncFiles\TIPS_AND_TRICKS_V16.Inc"
'/==============================================================================
    GoTo OverMacros                              ' Jump over the subroutines
'/==============================================================================


'/==============================================================================
OverMacros:
'/==============================================================================
                      
'/###############################################################################
'/ Main Demo Program
'/ Use the ISIS program to test the code.
'/ Click the ISIS button in the toolbar and choose the PIC18_ALCD_VHB.DSN board with normal LCD. 
'/###############################################################################
    Cls
MAIN:
    WDTCONBits_SWDTEN = 0   '/ Watchdog disabled por software.
'/------------------------------------------------------------------------------
    HRSOut "BCD COUNTERS: LENArray / LENBCDArray commands:",CR
    HRSOut "NUMBER OF COUNTERS: ",Dec __VBCD_CounterLenght, CR, CR

    Clear BCDArray1
    '/ Loading a value into the BCD counters
    BCDArray1#0 = 0
    BCDArray1#1 = 5    
    BCDArray1#2 = 0
    BCDArray1#3 = 8
    BCDArray1#4 = 0
    BCDArray1#5 = 0    
    BCDArray1#6 = 0  
    BCDArray1#7 = 0
    BCDArray1#8 = 0    
    BCDArray1#9 = 0 
    
    HRSOut "The Lenght of the Array must be: 4",CR
    '/ Calculate the numbers of numbers in the Array.
    MyResultByte = LENArray(BCDArray1,__VBCD_CounterLenght)
    HRSOut "LENArray: ", Dec MyResultByte,CR

    MyResultByte = LENBCDArray(1)
    HRSOut "LENBCDArray: ", Dec MyResultByte,CR,CR     

'/------------------------------------------------------------------------------
    Clear BCDArray2
    '/ Loading a value into the BCD counters
    BCDArray2#0 = 8
    BCDArray2#1 = 5    
    BCDArray2#2 = 7
    BCDArray2#3 = 0
    BCDArray2#4 = 1
    BCDArray2#5 = 5
    BCDArray2#6 = 4
    BCDArray2#8 = 0
    BCDArray2#9 = 0
            
    HRSOut "The Lenght of the Array must be: 7",CR
    '/ Calculate the numbers of numbers in the Array.
    MyResultByte = LENArray(BCDArray2,__VBCD_CounterLenght)
    HRSOut "LENArray: ", Dec MyResultByte,CR

    MyResultByte = LENBCDArray(2)
    HRSOut "LENBCDArray: ", Dec MyResultByte,CR,CR  

'/------------------------------------------------------------------------------
    Clear BCDArray3
    '/ No value into the BCDArray2
            
    HRSOut "The Lenght of the Array must be: 0",CR
    '/ Calculate the numbers of numbers in the Array.
    MyResultByte = LENArray(BCDArray3,__VBCD_CounterLenght)
    HRSOut "LENArray: ", Dec MyResultByte,CR

    MyResultByte = LENBCDArray(3)
    HRSOut "LENBCDArray: ", Dec MyResultByte,CR,CR  


    HRSOut "END TEST",CR     

Stop

'/##############################################################################
    End
'/==============================================================================
 
