'****************************************************************
'*  Name    : Test_Tips_and_Tricks.BAS                          *
'*  Author  : [Alberto Freixanet]                               *
'*  Notice  : Copyright (c) 2018 [AFreixanet]                   *
'*          : All Rights Reserved                               *
'*  Date    : 29/09/2018                                        *
'*  Version : 1.0                                               *
'*  Notes   : Check the Map8 / Map16 / MapF commands            *
'*          :                                                   *
'****************************************************************
'/ Choose the include file depending of clock of ISIS CPU.
    Include "D:\MyIncFiles\proton18_16.inc"

    Declare Float_Rounding = On             ' Round down to the nearest integer
'    Declare Reminders = Off
'    DECLARE LABEL_BANK_RESETS = ON
'    Declare Reminders = On
'    #define __INTERRUPTS_ENABLED 1

    Dim MyResultByte As Byte
    Dim MyResultWord As Word
    Dim MyResultSWord As SWord    
    Dim MyResultDword As Dword
    Dim MyResultFloat As Float

    Dim MyResultRDword As Word

    Dim MyInputByte As Byte
    Dim MyInputWord As Word
    Dim MyInputDword As Dword            
    Dim MyInputFloat As Float

    Dim WordLoop As Word
    Dim ByteLoop As Byte
    Dim Temperature As Byte
    Dim Temper16 As Word    

    
' Place the String at the End of the Dim list

'/==============================================================================
'/ UARTs
'    $define _HRSOutTwoStopBitsInc_
' Others libraries.
'    $define _ADCaverageA_
'    $define _ADCaverageB_    
'    $define _CountUntil_
'    $define _HEXtoASCII_
'    $define _IDLOCS_
'    $define _HRSLStrg_
'    $define _DegC_DegF_
    $define _Map8_
    $define _Map16_
    $define _MapF_    
'    $define _GIE_Save_
'    $define _DEVID1_
'    $define _BCDCounters_
'    $define _StringToFloat_
'    $define _DebounceByte_    
'    $define _MyRandom_
'    $define _GrayCode_

    $define __MEASURE_CODE_
'/------------------------------------------------------------------------------
    '/ Create your own path in the Hard disk D:\MyIncFiles.
    Include "D:\MyIncFiles\TIPS_AND_TRICKS_V16.Inc"
'/==============================================================================
    GoTo OverMacros                              ' Jump over the subroutines
'/==============================================================================


'/==============================================================================
OverMacros:
'/==============================================================================
                            
'/###############################################################################
'/ Main Demo Program
'/ Use the ISIS program to test the code.
'/ Click the ISIS button in the toolbar and choose the PIC18_ALCD_VHB.DSN board with normal LCD. 
'/###############################################################################
    Cls
MAIN:

'/------------------------------------------------------------------------------
    STARTSIZE(MAP8_CODE)
'/ Checking Variable Byte:

    Temperature = 18
    HRSOut "Input Temperature: ", Dec Temperature, 13
'/  Map8(pValue, Min In, Max In, Min Out, Max Out, Result)    
    HRSOut "Map8: Min Input: 0, Max Input: 32; Max Output: 0, Max Output: 16",CR
    MyResultWord = Map8(Temperature, 0, 31, 0, 16)
    HRSOut "Output Temperature: ", Dec MyResultWord, 13
    HRSOut CR

    Temperature = 8   
    HRSOut "Input Temperature: ", Dec Temperature, 13
'/  Map8(pValue, Min In, Max In, Min Out, Max Out, Result) 
    HRSOut "Map8: Min Input: 0, Max Input: 16; Max Output: 0, Max Output: 32",CR
    MyResultByte = Map8(Temperature, 0, 16, 0, 31)
    HRSOut "Output Temperature: ", Dec MyResultByte, 13
    HRSOut CR

    ENDSIZE(MAP8_CODE)

'/------------------------------------------------------------------------------
    STARTSIZE(MAP16_CODE) 
'/ Checking VariableWord:

    Temper16 = 500
    HRSOut "Input Temperature: ", Dec Temper16, 13
'/  Map16(pValue, Min In, Max In, Min Out, Max Out, Result)    
    HRSOut "Map16: Min Input: 0, Max Input: 1000; Max Output: 0, Max Output: 500",CR
    MyResultWord = Map16(Temper16, 0, 1000, 0, 500)
    HRSOut "Output Temperature: ", Dec MyResultWord, 13
    HRSOut CR

    Temper16 = 250
    HRSOut "Input Temperature: ", Dec Temper16, 13
'/  Map16(pValue, Min In, Max In, Min Out, Max Out, Result)
    HRSOut "Map16: Min Input: 0, Max Input: 500; Max Output: 0, Max Output: 1000",CR
    MyResultDword = Map16(Temper16, 0, 500, 0, 1000)
    HRSOut "Output Temperature: ", Dec MyResultDword, 13
    HRSOut CR    

    ENDSIZE(MAP16_CODE)
'/------------------------------------------------------------------------------
    STARTSIZE(MAPF_CODE)
'/ Checking VariableFloat:

    MyInputFloat = 4.456
    HRSOut "Input Float: ", Dec MyInputFloat, 13
'/  MapF(pValue, Min In, Max In, Min Out, Max Out, Result)
    HRSOut "MapF: Min Input: 0, Max Input: 10.0; Max Output: 0, Max Output: 20.0",CR
    MapF(MyInputFloat, 0, 10.0, 0, 20.0, MyResultFloat)
    HRSOut "Output Float: ", Dec MyResultFloat, 13
    HRSOut CR
    
    MyInputFloat = 175.5
    HRSOut "Input Float: ", Dec MyInputFloat, 13
'/  MapF(pValue, Min In, Max In, Min Out, Max Out, Result)
    HRSOut "MapF: Min Input: 0, Max Input: 300.0; Max Output: 0, Max Output: 100.0",CR
    MapF(MyInputFloat, 0, 300.0, 0, 100.0, MyResultFloat)
    HRSOut "Output Float: ", Dec MyResultFloat, 13

    HRSOut "END TEST",CR
    ENDSIZE(MAPF_CODE)

'/##############################################################################
    End
'/==============================================================================

