'****************************************************************
'*  Name    : Test_Tips_and_Tricks.BAS                          *
'*  Author  : [Alberto Freixanet]                               *
'*  Notice  : Copyright (c) 2018 [AFreixanet]                   *
'*          : All Rights Reserved                               *
'*  Date    : 04/10/2018                                        *
'* Purpose  : Check the RCON flags                              *
'*  Version : 1.0                                               *
'*  Notes   : Testing the HRSOut_RCON() command                 *
'****************************************************************

'/ Include files needed:
'/ Amicus18_25K22.Inc
'/ Tips_and_Tricks_V15.Inc
'/ DeclareLocalVars.Inc
'/ PICslist.inc

'/==============================================================================
    $define PLL_ConfigFuses On
    $define _CheckRCONBits_
    $define __WatchDog_ON
'/------------------------------------------------------------------------------
    '/ Create your own path in the Hard disk D:\MyIncFiles.
    Include "D:\MyIncFiles\Amicus18_25K22.inc"
'/==============================================================================
'    Declare Float_Display_Type = Fast
'    Declare Float_Rounding = On
    Declare Watchdog = OFF
'    #define __INTERRUPTS_ENABLED 1

    Declare LCD_DTPin = PORTB.4
    Declare LCD_RSPin = PORTC.0
    Declare LCD_ENPin = PORTC.1
    Declare LCD_Interface = 4
    Declare LCD_Lines = 2
    Declare LCD_Type = 0
    Declare LCD_CommandUs = 2000
    Declare LCD_DataUs = 50

'/==============================================================================
    $define _CLL_
    $define _MeasurePeriod_
    $define __MEASURE_CODE_
'/------------------------------------------------------------------------------
    '/ Create your own path in the Hard disk D:\MyIncFiles.
    Include "D:\MyIncFiles\Tips_and_Tricks_V16.inc"
'/==============================================================================
    Dim Frequency As Word
    Dim FrequencyFlt As Float
    Dim FreqDecimals As Word    
    Dim MyLoop As Byte

    Dim SoftResetButton As PORTC.2
    Dim WDTButton As PORTC.3
    Dim Oscilloscope As LATC.4        
'/==============================================================================        
    GoTo OverMacro       

          
'/==============================================================================
OverMacro:
START:
    HRSOut_RCON()   '/ Print the status of the PIC.
    DelayMS 500
    Cls
    SSP1STAT = 0
    SSP1CON1 = 0
    Input SoftResetButton
    Input WDTButton
    Low Oscilloscope
'/------------------------------------------------------------------------------
    HRSOut "TEST MEASURE PERIOD:",CR,CR

    MyLoop = 0
    Do
'/      Output Frequency        Output decimals
        Set Oscilloscope
        FrequencyFlt = MeasureFreq(100,3)
        Clear Oscilloscope

        Inc MyLoop
        If MyLoop = 100 Then
            MyLoop = 0        
        EndIf
        CLL(1,9)
        Print At 1,1,"LP", Dec2 MyLoop," CP ", Dec _mpCaptureValue
        CLL(2,7)
        Print At 2,1,"FREQ: ", Dec FrequencyFlt,"Hz"


        While SoftResetButton = 0
            Reset
        Wend    

        While WDTButton = 0 
            Nop
        Wend

        DelayMS 100

    Loop

   
'/------------------------------------------------------------------------------
    End
        
     
