'****************************************************************
'*  Name    : Test_Tips_and_Tricks.BAS                          *
'*  Author  : [Alberto Freixanet]                               *
'*  Notice  : Copyright (c) 2018 [AFreixanet]                   *
'*          : All Rights Reserved                               *
'*  Date    : 29/08/2018                                        *
'*  Version : 1.0                                               *
'*  Notes   : Check the Shift Array Bits commands               *
'*          :                                                   *
'****************************************************************
'/ Choose the include file depending of clock of ISIS CPU.
    Include "D:\MyIncFiles\proton18_16.inc"

'    Declare Float_Display_Type = Fast
'    Declare Float_Rounding = On             ' Round down to the nearest integer
    Declare Watchdog = On
'    Declare Reminders = Off
'    DECLARE LABEL_BANK_RESETS = ON
'    Declare Reminders = On
    #define __INTERRUPTS_ENABLED 1
'    #define watchdog_req

    Dim MyResultByte As Byte
    Dim MyResultWord As Word
    Dim MyResultSWord As SWord    
    Dim MyResultDword As Dword
    Dim MyResultFloat As Float

    Dim MyResultRDword As Word

    Dim MyInputByte As Byte
    Dim MyInputWord As Word
    Dim MyInputDword As Dword            
    Dim MyInputFloat As Float

    Dim WordLoop As Word
    Dim ByteLoop As Byte
    
' Place the String at the End of the Dim list
    Symbol MyArray1Lenght = 5
    Dim MyArray1[MyArray1Lenght] As Byte

'/==============================================================================
'/ UARTs
'    $define _HRSOutTwoStopBitsInc_
' Others libraries.
'    $define _ADCaverageA_
'    $define _ADCaverageB_    
'    $define _CountUntil_
'    $define _HEXtoASCII_
'    $define _IDLOCS_
'    $define _HRSLStrg_
'    $define _DegC_DegF_
'    $define _Map8_
'    $define _Map16_
'    $define _MapF_    
'    $define _DEVID1_
'    $define _BCDCounters_
'    $define _StringToFloat_
'    $define _DebounceByte_    
'    $define _MyRandom_
'    $define _GrayCode_
'    $define _RotateBits_
    $define _ArrayROL_
    $define _ArrayROR_
    $define _ArrayROLR_
    $define _ArrayRORR_
    
    $define __MEASURE_CODE_
'/------------------------------------------------------------------------------
    '/ Create your own path in the Hard disk D:\MyIncFiles.
    Include "D:\MyIncFiles\TIPS_AND_TRICKS_V16.Inc"
'/==============================================================================
    GoTo OverMacros                              ' Jump over the subroutines
'/==============================================================================


'/==============================================================================
OverMacros:
'/==============================================================================
                            
'/###############################################################################
'/ Main Demo Program
'/ Use the ISIS program to test the code.
'/ Click the ISIS button in the toolbar and choose the PIC18_ALCD_VHB.DSN board with normal LCD. 
'/###############################################################################
    Cls
MAIN:
   STARTSIZE(ROTATE_BITS_CODE)
'/------------------------------------------------------------------------------

    HRSOut "TESTING THE ROTATE ARRAY BITS COMMAND:",CR,CR

    '/ Loading the array with $F0 number.
    LoadArray(MyArray1,MyArray1Lenght,$F0)
    HRSOut "MyArray1: %",Bin8 MyArray1#4," ",Bin8 MyArray1#3," ",Bin8 MyArray1#2," ",Bin8 MyArray1#1," ",Bin8 MyArray1#0,CR 
    HRSOut CR

    HRSOut "SHIFTING TO THE LEFT (ArrayROL) 3 TIMES:",CR
    '/ Shift the Array all bits 3 times to the left. (The bits of the left are lost)
    For ByteLoop = 0 To 2
        ArrayROL(MyArray1,MyArray1Lenght)
    Next
    HRSOut "MyArray1: %",Bin8 MyArray1#4," ",Bin8 MyArray1#3," ",Bin8 MyArray1#2," ",Bin8 MyArray1#1," ",Bin8 MyArray1#0,CR
    HRSOut CR    

    HRSOut "SHIFTING TO THE LEFT (ArrayROL) 9 TIMES:",CR
    '/ Shift the Array all bits 9 times To the left. (The bits of the left are lost)
    For ByteLoop = 0 To 8
        ArrayROL(MyArray1,MyArray1Lenght)
    Next
    HRSOut "MyArray1: %",Bin8 MyArray1#4," ",Bin8 MyArray1#3," ",Bin8 MyArray1#2," ",Bin8 MyArray1#1," ",Bin8 MyArray1#0,CR
    HRSOut CR

    HRSOut "SHIFTING TO THE RIGHT (ArrayROR) 12 TIMES:",CR
    '/ Shift the Array all bits 12 times To the Right. (The bits of the right are lost)
    For ByteLoop = 0 To 11
        ArrayROR(MyArray1,MyArray1Lenght)
    Next
    HRSOut "MyArray1: %",Bin8 MyArray1#4," ",Bin8 MyArray1#3," ",Bin8 MyArray1#2," ",Bin8 MyArray1#1," ",Bin8 MyArray1#0,CR
    HRSOut CR,CR

'/------------------------------------------------------------------------------

    '/ Loading the array with $F0 number.
    LoadArray(MyArray1,MyArray1Lenght,$F0)
    HRSOut "MyArray1: %",Bin8 MyArray1#4," ",Bin8 MyArray1#3," ",Bin8 MyArray1#2," ",Bin8 MyArray1#1," ",Bin8 MyArray1#0,CR 
    HRSOut CR

    HRSOut "SHIFTING TO THE LEFT (ArrayROLR) 6 TIMES:",CR
    '/ Shift the Array all bits 3 times to the left. (The bits of the left pass to the right)
    For ByteLoop = 0 To 5
        ArrayROLR(MyArray1,MyArray1Lenght)
    Next
    HRSOut "MyArray1: %",Bin8 MyArray1#4," ",Bin8 MyArray1#3," ",Bin8 MyArray1#2," ",Bin8 MyArray1#1," ",Bin8 MyArray1#0,CR
    HRSOut CR    

    HRSOut "SHIFTING TO THE RIGHT (ArrayRORR) 6 TIMES:",CR
    '/ Shift the Array all bits 12 times To the Right. (The bits in the right pass to the left)
    For ByteLoop = 0 To 5
        ArrayRORR(MyArray1,MyArray1Lenght)
    Next
    HRSOut "MyArray1: %",Bin8 MyArray1#4," ",Bin8 MyArray1#3," ",Bin8 MyArray1#2," ",Bin8 MyArray1#1," ",Bin8 MyArray1#0,CR
    HRSOut CR

    HRSOut "END TEST",CR

    Stop

'/------------------------------------------------------------------------------
    ENDSIZE(ROTATE_BITS_CODE)
'/##############################################################################
    End
'/==============================================================================
  
