'****************************************************************
'*  Name    : TEST_Time_25K20.BAS                               *
'*  Author  : [Alberto Freixanet] 2009                          *
'*  Notice  : Copyright (c) 2013                                *
'*          : All Rights Reserved                               *
'*  Date    : 29/09/2018                                        *
'*  Version : 2.0 Added more Processors functions  and crystals *
'*  Notes   : Testing code Time with ISIS and Amicus18 Boards   *
'****************************************************************

'/ Include files needed:
'/ Amicus18_25K22.Inc
'/ Tips_and_Tricks_V14.Inc
'/ DeclareLocalVars.Inc
'/ PICslist.inc

'/==============================================================================
    $define PLL_ConfigFuses On
    $define _CheckRCONBits_
'    $define __TestInterruptsEnabled
'/------------------------------------------------------------------------------
    '/ Create your own path in the Hard disk D:\MyIncFiles.
    Include "D:\MyIncFiles\Amicus18_25K20.inc"
'/==============================================================================
'    Declare Float_Display_Type = Fast
'    Declare Float_Rounding = On
    Declare Watchdog = OFF
'    #define __INTERRUPTS_ENABLED 1

    Declare LCD_DTPin = PORTB.4
    Declare LCD_RSPin = PORTC.0
    Declare LCD_ENPin = PORTC.1
    Declare LCD_Interface = 4
    Declare LCD_Lines = 2
    Declare LCD_Type = 0
    Declare LCD_CommandUs = 2000
    Declare LCD_DataUs = 50

    Dim MyResultByte As Byte
    Dim MyResultWord As Word
    Dim MyResultDword As Dword
    Dim MyResultFloat As Float

    Dim MyInputByte As Byte
    Dim MyInputWord As Word
    Dim MyInputDword As Dword            
    Dim MyInputFloat As Float

    Dim WordLoop As Word
    Dim ByteLoop As Byte

' Place the String at the End of the Dim list

'===============================================================================
    $define _CLL_
    $define _MeasureTime_
    $define __MEASURE_CODE_
'/------------------------------------------------------------------------------
    '/ Create your own path in the Hard disk D:\MyIncFiles.
    Include "D:\MyIncFiles\TIPS_AND_TRICKS_V16.Inc"
'/==============================================================================
    GoTo OverMacros                              ' Jump over the subroutines
'/==============================================================================


'/==============================================================================
OverMacros:
'/==============================================================================
                            
'/###############################################################################
'/ Main Demo Program
'/ Use the ISIS program to test the code.
'/ Click the ISIS button in the toolbar and choose the PIC18_ALCD_VHB.DSN board with normal LCD. 
'/###############################################################################
MAIN:
    HRSOut_RCON()   '/ Check states of the PIC.
    CLL()
'-------------------------------------------------------------------------------
    MeasureTime_Init()

' Don't write under the line
'===============================================================================
    MTimerOn()
'===============================================================================
' Write your code to test under the line.
'===============================================================================
'    nop

    DelayUS 1565
    
'===============================================================================
'===============================================================================
    MTimerStop()
    MPrint_TMRResult()
    HRSOut "END TEST",CR
'*******************************************************************************
    End
'/------------------------------------------------------------------------------


